SystemOrganization addCategory: #Bundleview!

Slider subclass: #InterpolationSlider
	instanceVariableNames: 'type gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:57'!
content
	"Answer the value of content"

	^ content! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:57'!
content: anObject
	"Set the value of content"

	content := anObject! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:59'!
gui
	"Answer the value of gui"

	^ gui! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:59'!
gui: anObject
	"Set the value of gui"

	gui := anObject! !

!InterpolationSlider methodsFor: 'as yet unclassified' stamp: 'CR 1/10/2013 09:55'!
mouseUpInSlider: event

	super mouseUpInSlider: event.
	"change view"
	self type = 't' ifTrue: [self gui mainWindow relationOptions t: self value].
	self type = 'K' ifTrue: [self gui mainWindow relationOptions springStrengthK: self value].
	self type = 'threshold' ifTrue: [self gui mainWindow relationOptions treshholdCompatibility: self value].
	self gui mainWindow rebuildTree.! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:57'!
textMorph
	"Answer the value of textMorph"

	^ textMorph! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:57'!
textMorph: anObject
	"Set the value of textMorph"

	textMorph := anObject! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 23:02'!
type
	"Answer the value of type"

	^ type! !

!InterpolationSlider methodsFor: 'accessing' stamp: 'CR 1/9/2013 23:02'!
type: anObject
	"Set the value of type"

	type := anObject! !

!InterpolationSlider methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 23:06'!
value: newValue
	super value: newValue.
	self type = 'K' ifTrue: [self gui sliderValueTextMorphForK ifNotNil: [self gui sliderValueTextMorphForK contents: 'K: ', (self value roundDownTo: 0.01)]].
	self type = 't' ifTrue: [self gui sliderValueTextMorphForT ifNotNil: [self gui sliderValueTextMorphForT contents: 't: ', (self value roundDownTo: 0.01)]].
	self type = 'threshold' ifTrue: [self gui sliderValueTextMorphForThreshold ifNotNil: [self gui sliderValueTextMorphForThreshold contents: 'limit: ', (self value roundDownTo: 0.01)]].! !

!InterpolationSlider methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 23:01'!
value: newValue forTextMorph: aTextMorph withContent: aString
	super value: newValue.
	aTextMorph ifNotNil: [aTextMorph contents: aString, (self value roundDownTo: 0.01)].! !

Morph subclass: #GUIStepper
	instanceVariableNames: 'stepTime receiver methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUIStepper methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 22:41'!
initialize
	"comment stating purpose of message"
	super initialize.
	self
		receiver: Project new;
		methodSelector: #beep;
		stepTime: 10;
		x: -100;
		y: -100;
		openInWorld;
		stopStepping.! !

!GUIStepper methodsFor: 'accessing' stamp: 'SL 1/5/2013 13:32'!
methodSelector
	"Answer the value of methodSelector"

	^ methodSelector! !

!GUIStepper methodsFor: 'accessing' stamp: 'SL 1/5/2013 13:32'!
methodSelector: anObject
	"Set the value of methodSelector"

	methodSelector := anObject! !

!GUIStepper methodsFor: 'accessing' stamp: 'SL 1/5/2013 13:32'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!GUIStepper methodsFor: 'accessing' stamp: 'SL 1/5/2013 13:32'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!GUIStepper methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 13:32'!
step
	"performs given method on given object in steptime"
	self receiver perform: self methodSelector.! !

!GUIStepper methodsFor: 'accessing' stamp: 'SL 1/5/2013 13:32'!
stepTime: anObject
	"Set the value of stepTime"

	stepTime := anObject! !

GUIStepper subclass: #GUIStepperNodeMover
	instanceVariableNames: 'node source target mainwindow stepsTaken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUIStepperNodeMover methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 22:31'!
initializeWithParent: aMainWindow Source: aNode AndTarget: aPoint
	self
		stepsTaken: 0;
		stepTime: 10;
		node: Node new;
		source: (aNode x @ aNode y);
		target: aPoint + (aMainWindow x @ aMainWindow y).
	self node x: aNode x.
	self node y: aNode y.
	self node size: aNode size.
	self node label: aNode label.
	ShapeRenderer drawNode: self node On: aMainWindow.
	self startStepping
	! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 22:08'!
mainwindow
	"Answer the value of mainwindow"

	^ mainwindow! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 22:08'!
mainwindow: anObject
	"Set the value of mainwindow"

	mainwindow := anObject! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:51'!
node
	"Answer the value of node"

	^ node! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:51'!
node: anObject
	"Set the value of node"

	node := anObject! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:50'!
source
	"Answer the value of source"

	^ source! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:50'!
source: anObject
	"Set the value of source"

	source := anObject! !

!GUIStepperNodeMover methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 22:32'!
step
	"comment stating purpose of message"
	| diff |
	self stepsTaken: self stepsTaken + 1.
	diff := self target - self source.
	self node x: self node x + (diff x * 0.1).
	self node y: self node y + (diff y * 0.1).
	ShapeRenderer drawNode: self node On: self mainwindow.
	(self stepsTaken > 10) ifTrue: [
		self stopStepping.
	].
	^self ! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 22:31'!
stepsTaken
	"Answer the value of stepsTaken"

	^ stepsTaken! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 22:31'!
stepsTaken: anObject
	"Set the value of stepsTaken"

	stepsTaken := anObject! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:50'!
target
	"Answer the value of target"

	^ target! !

!GUIStepperNodeMover methodsFor: 'accessing' stamp: 'SL 1/5/2013 21:51'!
target: anObject
	"Set the value of source"

	target := anObject! !

Object subclass: #BSpline
	instanceVariableNames: 'tesselatedPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:31'!
addTesselatedPoint: aPoint

	tesselatedPoints add: aPoint.! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:24'!
calculateBSpline: aPointList
	
	| skm1 cpim1 cpi cpip1 sk line rkm1 lk |
	(aPointList size < 4) ifTrue: [^self].
	self addTesselatedPoint: (aPointList at: 1).
	
	skm1 := aPointList at: 1.
	cpim1 := skm1.
	cpi := aPointList at: 2.
	
	2 to: (aPointList size - 2) do: [ :i | | pointsForCurve |
		pointsForCurve := OrderedCollection new.
		(i = (aPointList size - 2))
			ifTrue: [sk := cpi.]
			ifFalse: [cpip1 := aPointList at: (i + 1).
				sk := ((cpim1 + (4 * cpi) + cpip1)/6).].
		line := cpi - cpim1.
		rkm1 := cpim1 + ((line * 1)/3).
		lk := cpim1 + ((line *2)/3).
		pointsForCurve add: skm1.
		pointsForCurve add: rkm1.
		pointsForCurve add: lk.
		pointsForCurve add: sk.
		self calculateBezier: pointsForCurve.
		skm1 := sk.
		cpim1 := cpi.
		cpi := cpip1.].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:45'!
calculateCubicBezier: aPointList
	"comment stating purpose of message"

	| bernstein0 bernstein1 bernstein2 bernstein3 calculatedPoint step stepsize t|
	stepsize := 10.
	(aPointList size = 4) ifTrue: [
		step := 1 / (stepsize - 1).
		1 to: stepsize do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t) * (1 - t).
			bernstein1 := 3 * t * (1 - t) * (1 - t).
			bernstein2 := 3 * t * t * (1 - t).
			bernstein3 := t * t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 1) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein2).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein3).
			"self halt."
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:44'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self addTesselatedPoint: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: amountOfSteps do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self addTesselatedPoint: calculatedPoint.
		]].! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/21/2012 17:37'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!BSpline methodsFor: 'initialize' stamp: 'CR 10/23/2012 14:33'!
initialize: aPointList
	"calculates the tesselatedPoints from the given control points"

	tesselatedPoints := OrderedCollection new.
	(aPointList size = 3) ifTrue: [self calculateQuadraticBezier: aPointList.] ifFalse: [Transcript show: 'calculation of BSpline'] .
! !

!BSpline methodsFor: 'rendering' stamp: 'CR 10/23/2012 14:11'!
render

	ShapeRenderer drawPolyLine: self tesselatedPoints.! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!BSpline methodsFor: 'accessing' stamp: 'CR 10/21/2012 17:27'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

Object subclass: #ClickState
	instanceVariableNames: 'mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

ClickState subclass: #AddNodeClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!AddNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:22'!
handleMainWindowClick: aNodeMorph
	^self! !

!AddNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:20'!
handleNodeClick: aNodeMorph
	aNodeMorph addChildNode.! !

ClickState subclass: #AddRelationClickState
	instanceVariableNames: 'sourceNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!AddRelationClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:22'!
handleMainWindowClick: aNodeMorph
	^self! !

!AddRelationClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:20'!
handleNodeClick: aNodeMorph
	self sourceNode ifNil: [self sourceNode: aNodeMorph node]
	 ifNotNil: [ | relation notAllowedConnection |
		notAllowedConnection := false.
		notAllowedConnection := notAllowedConnection | (sourceNode hasAncestor: aNodeMorph node).
		notAllowedConnection := notAllowedConnection | (aNodeMorph node hasAncestor: sourceNode).
		notAllowedConnection := notAllowedConnection | (sourceNode == aNodeMorph node).
		notAllowedConnection ifFalse: [
			relation := Relation new.
			relation setSource: self sourceNode andDestination: aNodeMorph node.
			relation relationOptions: self mainWindow relationOptions.
			aNodeMorph updateTree.
		].
		self sourceNode: nil.
	].! !

!AddRelationClickState methodsFor: 'accessing' stamp: 'CR 12/26/2012 14:18'!
sourceNode
	"Answer the value of sourceNode"

	^ sourceNode! !

!AddRelationClickState methodsFor: 'accessing' stamp: 'CR 12/26/2012 14:18'!
sourceNode: anObject
	"Set the value of sourceNode"

	sourceNode := anObject! !

!ClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:21'!
handleMainWindowClick: aNodeMorph
	 ^ self subclassResponsibility.! !

!ClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:19'!
handleNodeClick: aNodeMorph
	 ^ self subclassResponsibility.! !

!ClickState methodsFor: 'accessing' stamp: 'CR 12/28/2012 12:08'!
mainWindow
	"Answer the value of mainWindow"

	^ mainWindow! !

!ClickState methodsFor: 'accessing' stamp: 'CR 12/28/2012 12:08'!
mainWindow: anObject
	"Set the value of mainWindow"

	mainWindow := anObject! !

ClickState subclass: #DefaultClickState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!DefaultClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:13'!
handleMainWindowClick: aNodeMorph
	"this clickstate should do nothing"
	^self! !

!DefaultClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:13'!
handleNodeClick: aNodeMorph
	"this clickstate should do nothing"
	^self! !

ClickState subclass: #MoveNodeClickState
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!MoveNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 20:20'!
handleMainWindowClick: anEvent
	self node ifNotNil: [self node position: anEvent cursorPoint].! !

!MoveNodeClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:30'!
handleNodeClick: aNodeMorph
	 self node: aNodeMorph.! !

!MoveNodeClickState methodsFor: 'accessing' stamp: 'CR 1/8/2013 15:30'!
node
	"Answer the value of node"

	^ node! !

!MoveNodeClickState methodsFor: 'accessing' stamp: 'CR 1/8/2013 15:30'!
node: anObject
	"Set the value of node"

	node := anObject! !

ClickState subclass: #SelectTwoNodesClickState
	instanceVariableNames: 'firstNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!SelectTwoNodesClickState methodsFor: 'accessing' stamp: 'SL 1/5/2013 14:23'!
firstNode
	"Answer the value of firstNode"

	^ firstNode! !

!SelectTwoNodesClickState methodsFor: 'accessing' stamp: 'SL 1/5/2013 14:23'!
firstNode: anObject
	"Set the value of firstNode"

	firstNode := anObject! !

!SelectTwoNodesClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 19:42'!
handleMainWindowClick: anEvent
	^self! !

!SelectTwoNodesClickState methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 19:42'!
handleNodeClick: aNodeMorph
	self firstNode ifNil: [self firstNode: aNodeMorph node]
	 ifNotNil: [ | relation notAllowedConnection |
		notAllowedConnection := false.
		notAllowedConnection := notAllowedConnection | (firstNode hasAncestor: aNodeMorph node).
		notAllowedConnection := notAllowedConnection | (aNodeMorph node hasAncestor: firstNode).
		notAllowedConnection := notAllowedConnection | (firstNode == aNodeMorph node).
		notAllowedConnection ifFalse: [
			relation := Relation new.
			relation setSource: self firstNode andDestination: aNodeMorph node.
			self firstNode highlightPathTo: aNodeMorph node.
			"reset clickstate"
			aNodeMorph gui clickState: DefaultClickState new.
			aNodeMorph gui source: self firstNode.
			aNodeMorph gui destination: aNodeMorph node.
			aNodeMorph gui step: 'init'.
			aNodeMorph gui stepCounter: 0.
			aNodeMorph updateTree.
		].
		self firstNode: nil.
	].! !

Object subclass: #FirstClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:36'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	""
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((-1 * (p1 x)) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/18/2012 17:03'!
countBackwards: x
	"counts a given number backwards till zero"
	| temp |
	temp := x.
	[temp > 0] whileTrue: [
		temp := temp - 1.
		Transcript show: temp
	].! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:00'!
drawACircleAt: aPoint
	"drawing a circle."
	| morph size |
	size := 20.
	morph := CircleMorph new.
	morph bounds: (Rectangle origin: (aPoint - ((size@size)/2)) extent: (size@size)).
	morph color: Color random.
	"morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen."
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:24'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 13:30'!
drawAPolyLine
	"showcase for drawing a polygon line."
	| morph |
	morph := PolygonMorph new.
	morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 14:19'!
drawBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	| morph bSplineMorph spline |
	morph := PolygonMorph new.
	morph setVertices: hullPoints.
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 2.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.
	
	spline := OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	spline addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].

	bSplineMorph := PolygonMorph new.
	bSplineMorph setVertices: spline.
	bSplineMorph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	bSplineMorph borderWidth: 2.
	bSplineMorph borderColor:  (Color h: 10 s: 1.0 v: 1.0 alpha: 1.0).
	bSplineMorph makeOpen.
	bSplineMorph openInWorld.
	
	! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/17/2012 15:57'!
firstMethod
	^self.! !

Object subclass: #GUI
	instanceVariableNames: 'systemWindow mainWindow buttonDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

GUI subclass: #FDEBGUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FDEBGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 08:53'!
initialize
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: FDEBMainWindow new.
	self systemWindow
		label: 'Force-Directed Edge Bundling';
		addMorph: self mainWindow frame: (0.2@0 corner: 1@1).
	
	self initializeCompatibilityButtonsWithTop: 0.0 AndRight: 0.2.
	
	self systemWindow openInWorld.
	self mainWindow fillMainWindow.
	self systemWindow bounds: (500@167 corner: 1080@622).! !

!FDEBGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:31'!
initializeCompatibilityButtonsWithTop: top AndRight: right
	| scale position angle visibility full |
	scale := self initializeButtonWithAction: [
		self mainWindow compatibilityState: 'scale'.
		self mainWindow rebuildMorphs.].
	scale label: 'scale'.
	position := self initializeButtonWithAction: [
		self mainWindow compatibilityState: 'position'.
		self mainWindow rebuildMorphs.].
	position label: 'position'.
	angle := self initializeButtonWithAction: [
		self mainWindow compatibilityState: 'angle'.
		self mainWindow rebuildMorphs.].
	angle label: 'angle'.
	visibility := self initializeButtonWithAction: [
		self mainWindow compatibilityState: 'visibility'.
		self mainWindow rebuildMorphs.].
	visibility label: 'visibility'.
	full := self initializeButtonWithAction: [
		self mainWindow compatibilityState: 'full'.
		self mainWindow rebuildMorphs.].
	full label: 'full'.
	
	self systemWindow addMorph: angle frame: (0.0@(top) corner: right@(top + 0.1)).
	self systemWindow addMorph: scale frame: (0.0@(top + 0.1) corner: right@(top + 0.2)).
	self systemWindow addMorph: position frame: (0.0@(top + 0.2) corner: right@(top + 0.3)).
	self systemWindow addMorph: visibility frame: (0.0@(top + 0.3) corner: right@(top + 0.4)).
	self systemWindow addMorph: full frame: (0.0@(top + 0.4) corner: right@(top + 0.5)).
	! !

!GUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:06'!
addMorph: aButton frame: aFrame
	self systemWindow addMorph: aButton frame: aFrame.
	self buttonDict at: aButton label put: aButton. 
	 ! !

!GUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:13'!
addMorph: aMorph frame: aFrame withKey: aKey
	self systemWindow addMorph: aMorph frame: aFrame.
	self buttonDict at: aKey put: aMorph. 
	 ! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 11:04'!
buttonDict
	"Answer the value of buttonDict"

	^ buttonDict! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 11:04'!
buttonDict: anObject
	"Set the value of buttonDict"

	buttonDict := anObject! !

!GUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:05'!
initialize
	super initialize.
	self buttonDict: Dictionary new.! !

!GUI methodsFor: 'initialize' stamp: 'CR 1/5/2013 13:00'!
initializeButtonWithAction: aBlock
	| aButton |
	aButton := PluggableButtonMorphPlus
		on: aBlock
		getState: nil
		action: #value.
	^aButton.! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
mainWindow
	"Answer the value of mainWindow"

	^ mainWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
mainWindow: anObject
	"Set the value of mainWindow"

	mainWindow := anObject! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
systemWindow
	"Answer the value of systemWindow"

	^ systemWindow! !

!GUI methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:29'!
systemWindow: anObject
	"Set the value of systemWindow"

	systemWindow := anObject! !

GUI subclass: #MainGUI
	instanceVariableNames: 'sliderValueTextMorphForT sliderValueTextMorphForK sliderValueTextMorphForThreshold hebMorphLabels fdebMorphLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!MainGUI methodsFor: 'drawing' stamp: 'CR 12/26/2012 12:59'!
addMorphToMainWindow: aMorph
	"add Morph to the mainWindow"
	"if the position is outside of the mainWindow it is set to the upper left corner"
	(((((aMorph position) x) < ((self mainWindow upperLeftPointOfMainWindow) x) or:
	((aMorph position) y) < ((self mainWindow upperLeftPointOfMainWindow) y)) or:
	((aMorph position) x) > ((self mainWindow lowerRightPointOfMainWindow) x)) or:
	((aMorph position) y) > ((self mainWindow lowerRightPointOfMainWindow) y)) ifTrue: [
		"the morph is left or above the mainWindow"
		aMorph position: self mainWindow upperLeftPointOfMainWindow.].
	self mainWindow addMorph: aMorph.! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/28/2012 16:25'!
buttonActionCreateExampleTree1
	^[self mainWindow removeAllMorphs.
		self mainWindow rootNode: TreeBuilder buildTestTree.
		self mainWindow rebuildTree.]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 19:34'!
buttonActionCreateExampleTree2
	^[self mainWindow removeAllMorphs.
		self mainWindow rootNode: TreeBuilder buildLargeTree.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 19:56'!
buttonActionCreateRootNode
	^[ | rootNode |
		self mainWindow removeAllMorphs.
		rootNode := Node new.
		self mainWindow rootNode: rootNode.
		self mainWindow rebuildTree.]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:13'!
buttonActionInterpolateControlPoints
	^[
		self mainWindow relationOptions interpolateControlPoints ifTrue: [
			self mainWindow relationOptions interpolateControlPoints: false.
		] ifFalse: [
			self mainWindow relationOptions interpolateControlPoints: true.
			self mainWindow relationOptions interpolateCurvePoints: false.			
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:14'!
buttonActionInterpolateCurvePoints
	^[
		self mainWindow relationOptions interpolateCurvePoints ifTrue: [
			self mainWindow relationOptions interpolateCurvePoints: false.
		] ifFalse: [
			self mainWindow relationOptions interpolateCurvePoints: true.
			self mainWindow relationOptions interpolateControlPoints: false.			
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:20'!
buttonActionLCA
	^[
		self mainWindow relationOptions useLCA ifTrue: [
			self mainWindow relationOptions useLCA: false.
		] ifFalse: [
			self mainWindow relationOptions useLCA: true.
		].
		self mainWindow rebuildTree.
	].! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:11'!
buttonActionRadialLayout
	^[self mainWindow layoutType: 'radial'.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:16'!
buttonActionRemoveAllTrees
	^[self mainWindow removeAllMorphs.]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 20:10'!
buttonActionRootedLayout
	^[self mainWindow layoutType: 'rooted'.
		self mainWindow rebuildTree]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 15:05'!
buttonActionShowInterpolationOverlay
	^[
		self mainWindow relationOptions showInterpolationOverlay ifTrue: [
			self mainWindow relationOptions showInterpolationOverlay: false.
		] ifFalse: [
			self mainWindow relationOptions showInterpolationOverlay: true.
		].
		self mainWindow rebuildTree.
	]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 12/28/2012 14:55'!
buttonActionSpecialCase
	^[
		self mainWindow relationOptions checkForSpecialCase ifTrue: [
			self mainWindow relationOptions checkForSpecialCase: false.
		] ifFalse: [
			self mainWindow relationOptions checkForSpecialCase: true.
		].
		self mainWindow rebuildTree.
	]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 1/8/2013 22:32'!
buttonShowFDEBCalculation
	^[ FDEBGUI new.]! !

!MainGUI methodsFor: 'initialize' stamp: 'SL 1/5/2013 13:52'!
buttonShowPathCalculation
	^[ PathGUI new initializeWithParent: self.]! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 21:50'!
fdebMorphLabels
	"Answer the value of fdebMorphLabels"

	^ fdebMorphLabels! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 21:50'!
fdebMorphLabels: anObject
	"Set the value of fdebMorphLabels"

	fdebMorphLabels := anObject! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 21:50'!
hebMorphLabels
	"Answer the value of hebMorphLabels"

	^ hebMorphLabels! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 21:50'!
hebMorphLabels: anObject
	"Set the value of hebMorphLabels"

	hebMorphLabels := anObject! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:00'!
hideFDEBMorphs
	self fdebMorphLabels do: [:label |
		(self buttonDict at: label) hide.]! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 21:57'!
hideHEBMorphs
	self hebMorphLabels do: [:label |
		(self buttonDict at: label) hide.]! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 1/10/2013 10:01'!
initialize
	| numberOfButtonFields |
	super initialize.
	numberOfButtonFields := 4.
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: GUIMainWindow new.
	self hebMorphLabels: OrderedCollection new.
	self fdebMorphLabels: OrderedCollection new.
	self mainWindow initializeState.
	
	self systemWindow
		label: 'Edge Bundeling Demo';
		addMorph: mainWindow frame: (0.1@0.105 corner: 1@1).
	
	self initializeTreeModifierButtonsWithTop: 0.1 AndRight: 0.1.
	self initializeOpenNewWindowButtonsWithTop: 0.3 AndRight: 0.1.
	self initializeChangeRelationTypeButtonsWithBottom: 0.9 AndRight: 0.1. 
	self initializeCreateNewTreeButtonsWithBottom: 0.1 AndRight: (1/numberOfButtonFields).
	self initializeLayoutButtonsWithBottom: 0.1 AndLeft: (1/numberOfButtonFields) AndRight: (2/numberOfButtonFields).
	self initializeInterpolationButtonsWithBottom: 0.1 AndLeft: (2/numberOfButtonFields) AndRight: (3/numberOfButtonFields).
	self initializeFDEBButtonsWithBottom: 0.1 AndLeft: (2/numberOfButtonFields) AndRight: (3/numberOfButtonFields).
	self initializeLCAButtonsWithBottom: 0.1 AndLeft: (3/numberOfButtonFields) AndRight: (4/numberOfButtonFields).

	self hideFDEBMorphs.
	
	self systemWindow openInWorld.
	self systemWindow bounds: (172@39 corner: 1080@622).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:07'!
initializeChangeRelationTypeButtonsWithBottom: bottom AndRight: right
	| hebButton fdebButton|
	hebButton := self initializeButtonWithAction: [
		self mainWindow relationOptions useHierarchicalEdgeBundles: true.
		self hideFDEBMorphs.
		self showHEBMorphs.
		self mainWindow rebuildTree.].
	hebButton label: 'HEB'.
	fdebButton := self initializeButtonWithAction: [
		self mainWindow relationOptions useHierarchicalEdgeBundles: false.
		self hideHEBMorphs.
		self showFDEBMorphs.
		self mainWindow rebuildTree.].
	fdebButton label: 'FDEB'.
	
	self addMorph: hebButton frame: (0.001@(bottom - 0.2) corner: right@(bottom - 0.1)).
	self addMorph: fdebButton frame: (0.001@(bottom - 0.1) corner: right@bottom).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:08'!
initializeCreateNewTreeButtonsWithBottom: bottom AndRight: right
	| numberOfButtons buttonForCustomTree buttonForTree1 buttonForTree2 |
	numberOfButtons := 3.
	buttonForCustomTree := self initializeButtonWithAction: self buttonActionCreateRootNode.
	buttonForCustomTree label: 'build new tree'.
	buttonForTree1 := self initializeButtonWithAction: self buttonActionCreateExampleTree1.
	buttonForTree1 label: 'build simple tree'.
	buttonForTree2 := self initializeButtonWithAction: self buttonActionCreateExampleTree2.
	buttonForTree2 label: 'build complex tree'.
	
	self addMorph: buttonForCustomTree frame: (0@0 corner: right@(1/numberOfButtons*bottom)).
	self addMorph: buttonForTree1 frame: (0@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom )).
	self addMorph: buttonForTree2 frame: (0@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 23:03'!
initializeFDEBButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons useCompatibility kSlider thresholdSlider|
	numberOfButtons := 3.
	useCompatibility := self initializeButtonWithAction: [Transcript show: 'useCompatibility '].
	useCompatibility label: 'use Compatiblitity'.
	self fdebMorphLabels add: 'use Compatiblitity'.
	kSlider := InterpolationSlider new.
	kSlider gui: self.
	kSlider type: 'K'.
	kSlider value: 0.85 forTextMorph: self sliderValueTextMorphForK withContent: 'k'.
	thresholdSlider := InterpolationSlider new.
	thresholdSlider gui: self.
	thresholdSlider type: 'threshold'.
	thresholdSlider value: 0.85 forTextMorph: self sliderValueTextMorphForThreshold withContent: 'threshold'.
	
	self addMorph: useCompatibility frame: (left@0 corner: right@(1/numberOfButtons*bottom)).
	
	self addMorph: kSlider frame: ((left + ((right -left)/3))@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom)) withKey: 'kSlider'.
	self fdebMorphLabels add: 'kSlider'.
	self sliderValueTextMorphForK: StringMorph new.
	self sliderValueTextMorphForK contents: 'K: ', kSlider value.
	self initializeFDEBTextMorphWithLabel: 'K: ' value WithLeft: left AndRight: (left + ((right -left)/3)) AndBottom: (bottom -  (1/numberOfButtons*bottom)) AndTop: (1/numberOfButtons*bottom) ForMorph: self sliderValueTextMorphForK.
	
	self addMorph: thresholdSlider frame: ((left + ((right -left)/3))@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)) withKey: 'thresholdSlider'.
	self fdebMorphLabels add: 'thresholdSlider'.
	self sliderValueTextMorphForThreshold: StringMorph new.
	self sliderValueTextMorphForThreshold contents: 'limit: ', thresholdSlider value.
	self initializeFDEBTextMorphWithLabel: 'threshold: ' value WithLeft: left AndRight: (left + ((right - left)/3)) AndBottom: bottom AndTop: (2/numberOfButtons*bottom) ForMorph: self sliderValueTextMorphForThreshold.! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:48'!
initializeFDEBTextMorphWithLabel: label WithLeft: left AndRight: right AndBottom: bottom AndTop: top ForMorph: aMorph
	
	self addMorph: aMorph frame: (left@top corner: right@bottom) withKey: label.
	self fdebMorphLabels add: label.! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:36'!
initializeHEBTextMorphWithLabel: label WithLeft: left AndRight: right AndBottom: bottom AndTop: top
	
	self addMorph: self sliderValueTextMorphForT frame: (left@top corner: right@bottom) withKey: label.
	self hebMorphLabels add: label.! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 23:03'!
initializeInterpolationButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForControlPoints buttonForCurvePoints interpolationSlider |
	numberOfButtons := 3.
	buttonForControlPoints := self initializeButtonWithAction: self buttonActionInterpolateControlPoints.
	buttonForControlPoints label: 'Interpolate Control Points'.
	self hebMorphLabels add: 'Interpolate Control Points'.
	buttonForCurvePoints := self initializeButtonWithAction: self buttonActionInterpolateCurvePoints.
	buttonForCurvePoints label: 'Interpolate Curve Points'.
	self hebMorphLabels add: 'Interpolate Curve Points'.
	interpolationSlider := InterpolationSlider new.
	interpolationSlider gui: self.
	interpolationSlider type: 't'.
	interpolationSlider value: 0.85 forTextMorph: self sliderValueTextMorphForT withContent: 't'.
	
	self addMorph: buttonForControlPoints frame: (left@0 corner: right@(1/numberOfButtons*bottom)).
	self addMorph: buttonForCurvePoints frame: (left@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom)).
	self addMorph: interpolationSlider frame: ((left + ((right -left)/3))@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)) withKey: 'tSlider'.
	self hebMorphLabels add: 'tSlider'.
	self sliderValueTextMorphForT: StringMorph new.
	self sliderValueTextMorphForT contents: 't: ', interpolationSlider value.
	self initializeHEBTextMorphWithLabel: 't: ' value WithLeft: left AndRight: (left + ((right -left)/3)) AndBottom: bottom AndTop: (2/numberOfButtons*bottom).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 21:58'!
initializeLCAButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForInterpolationOverlay buttonForLCA buttonForSpecialCase |
	numberOfButtons := 3.
	buttonForInterpolationOverlay := self initializeButtonWithAction: self buttonActionShowInterpolationOverlay.
	buttonForInterpolationOverlay label: 'Show InterpolationOverlay'.
	self hebMorphLabels add: 'Show InterpolationOverlay'.
	buttonForLCA := self initializeButtonWithAction: self buttonActionLCA.
	buttonForLCA label: 'Do not use LCA'.
	self hebMorphLabels add: 'Do not use LCA'.
	buttonForSpecialCase := self initializeButtonWithAction: self buttonActionSpecialCase.
	buttonForSpecialCase label: 'Special Case for Path of Length 3'.
	self hebMorphLabels add: 'Special Case for Path of Length 3'.
	
	self addMorph: buttonForInterpolationOverlay frame: (left@0 corner: right@(1/numberOfButtons*bottom)).
	self addMorph: buttonForLCA frame: (left@(1/numberOfButtons*bottom) corner: right@(2/numberOfButtons*bottom)).
	self addMorph: buttonForSpecialCase frame: (left@(2/numberOfButtons*bottom) corner: right@(3/numberOfButtons*bottom)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:08'!
initializeLayoutButtonsWithBottom: bottom AndLeft: left AndRight: right
	| numberOfButtons buttonForRootedTree buttonForRadialTree |
	numberOfButtons := 2.
	buttonForRootedTree := self initializeButtonWithAction: self buttonActionRootedLayout.
	buttonForRootedTree label: 'use rooted trees'.
	buttonForRadialTree := self initializeButtonWithAction: self buttonActionRadialLayout.
	buttonForRadialTree label: 'use radial trees'.
	
	self addMorph: buttonForRootedTree frame: (left@0 corner: right@(1/numberOfButtons*bottom - 0.001)).
	self addMorph: buttonForRadialTree frame: (left@(1/numberOfButtons*bottom + 0.001) corner: right@(2/numberOfButtons*bottom - 0.001)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:09'!
initializeOpenNewWindowButtonsWithTop: top AndRight: right
	| showPathButton showFDEB |
	showPathButton := self initializeButtonWithAction: self buttonShowPathCalculation.
	showPathButton label: 'show Path'.
	showFDEB := self initializeButtonWithAction: self buttonShowFDEBCalculation.
	showFDEB label: 'explain FDEB'.
	
	self addMorph: showPathButton  frame: (0.0@top corner: right@(top + 0.1)).
	self addMorph: showFDEB  frame: (0.0@(top + 0.1) corner: right@(top + 0.2)).! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:19'!
initializeTextMorphWithLabel: label WithLeft: left AndRight: right AndBottom: bottom AndTop: top
	
	self addMorph: self sliderValueTextMorphForT frame: (left@top corner: right@bottom) withKey: label.
	self hebMorphLabels add: label.! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 11:09'!
initializeTreeModifierButtonsWithTop: top AndRight: right
	| addNodeButton addRelationButton removeButton |
	addNodeButton := self initializeButtonWithAction: [self mainWindow clickState: AddNodeClickState new].
	addNodeButton label: 'add Nodes'.
	addRelationButton := self initializeButtonWithAction: [self mainWindow clickState: AddRelationClickState new].
	addRelationButton label: 'add Relations'.
	removeButton := self initializeButtonWithAction: self buttonActionRemoveAllTrees.
	removeButton label: 'reset'.
	
	self addMorph: addNodeButton frame: (0.001@top corner: right@(top + 0.1)).
	self addMorph: addRelationButton frame: (0.001@(top + 0.1) corner: right@(top + 0.2)).
	self addMorph: removeButton frame: (0.001@0.9 corner: right@1).! !

!MainGUI methodsFor: 'initialize' stamp: 'CR 12/26/2012 16:34'!
prepareClickStateButtons
	| addNodeButton addRelationButton |
	addNodeButton := self initializeButtonWithAction: [self mainWindow state: AddNodeClickState new].
	addNodeButton label: 'add Nodes'.
	addRelationButton := self initializeButtonWithAction: [self mainWindow state: AddRelationClickState new].
	addRelationButton label: 'add Relations'.
	
	self mainWindow addMorph: addNodeButton atRelativePosition: 0.75@0.1 withExtend: 0.9@0.25.
	self mainWindow addMorph: addRelationButton  atRelativePosition: 0.75@0.3 withExtend: 0.9@0.45.! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 22:00'!
showFDEBMorphs
	self fdebMorphLabels do: [:label |
		(self buttonDict at: label) show.]! !

!MainGUI methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 21:59'!
showHEBMorphs
	self hebMorphLabels do: [:label |
		(self buttonDict at: label) show.]! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:20'!
sliderValueTextMorphForK
	"Answer the value of sliderValueTextMorphForK"

	^ sliderValueTextMorphForK! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:20'!
sliderValueTextMorphForK: anObject
	"Set the value of sliderValueTextMorphForK"

	sliderValueTextMorphForK := anObject! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:09'!
sliderValueTextMorphForT
	"Answer the value of sliderValueTextMorphForT"

	^ sliderValueTextMorphForT! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:09'!
sliderValueTextMorphForT: anObject
	"Set the value of sliderValueTextMorphForT"

	sliderValueTextMorphForT := anObject! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:20'!
sliderValueTextMorphForThreshold
	"Answer the value of sliderValueTextMorphForThreshold"

	^ sliderValueTextMorphForThreshold! !

!MainGUI methodsFor: 'accessing' stamp: 'CR 1/9/2013 22:20'!
sliderValueTextMorphForThreshold: anObject
	"Set the value of sliderValueTextMorphForThreshold"

	sliderValueTextMorphForThreshold := anObject! !

GUI subclass: #PathGUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!PathGUI methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:28'!
buttonActionSelect
	^[self mainWindow clickState: SelectTwoNodesClickState new.]! !

!PathGUI methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 17:35'!
buttonActionStep
	^[ self mainWindow stepForward.]! !

!PathGUI methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:11'!
initializeShowPathButtons: bottom
	| selectButton stepButton |
	selectButton := self initializeButtonWithAction: self buttonActionSelect.
	selectButton label: 'select relation'.
	stepButton := self initializeButtonWithAction: self buttonActionStep.
	stepButton label: 'next step'.
	
	self systemWindow addMorph: selectButton frame: (0@0 corner: 0.5@bottom).
	self systemWindow addMorph: stepButton frame: (0.5@0 corner: 1@bottom). ! !

!PathGUI methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:22'!
initializeWithParent: aMainGUI
	self systemWindow: PluggableSystemWindow new.
	self mainWindow: PathMainWindow new.
	self mainWindow clickState: DefaultClickState new.
	self systemWindow
		label: 'show Path Calculation';
		addMorph: self mainWindow frame: (0@0.1 corner: 1@1).
	
	self initializeShowPathButtons: 0.1.
	self systemWindow openInWorld.
	self systemWindow bounds: (500@167 corner: 1080@622).
	
	"get information of parent window"
	self mainWindow layoutType: aMainGUI mainWindow layoutType.
	self mainWindow rootNode: aMainGUI mainWindow rootNode copy.
	self mainWindow rebuildTree.! !

Object subclass: #InterpolationOverlay
	instanceVariableNames: 'relation pathNodes interpolatedNodes directLineNodes pathLine interpolatedLine directLine crossLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:22'!
abandon
	"lines"
	self directLine ifNotNil: [
		self directLine abandon.
		self directLine: nil.
	].
	self interpolatedLine ifNotNil: [
		self interpolatedLine abandon.
		self interpolatedLine: nil.
	].
	self pathLine ifNotNil: [
		self pathLine abandon.
		self pathLine: nil.
	].
	self crossLines ifNotNil: [
		self crossLines do: [ :morph |
			morph abandon.
		].
		self crossLines: nil.
	].
	"circles"
	self interpolatedNodes ifNotNil: [
		self interpolatedNodes do: [ :morph |
			morph abandon.
		].
		self interpolatedNodes: nil.
	].
	self directLineNodes ifNotNil: [
		self directLineNodes do: [ :morph |
			morph abandon.
		].
		self directLineNodes: nil.
	].
	self pathNodes ifNotNil: [
		self pathNodes do: [ :morph |
			morph abandon.
		].
		self pathNodes: nil.
	].
! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:52'!
crossLines
	"Answer the value of crossLines"

	^ crossLines! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:52'!
crossLines: anObject
	"Set the value of crossLines"

	crossLines := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLine
	"Answer the value of directLine"

	^ directLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLine: anObject
	"Set the value of directLine"

	directLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLineNodes
	"Answer the value of directLineNodes"

	^ directLineNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
directLineNodes: anObject
	"Set the value of directLineNodes"

	directLineNodes := anObject! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:19'!
drawNewOn: aMorph
	| pathTempNodes tempT pathPoints interpolatedPoints directLinePoints size |
	
"		aRelation relationOptions showInterpolationOverlay ifNotNil: [
		aRelation relationOptions showInterpolationOverlay ifTrue: [
"
	self relation interpolateControlPoints ifTrue: [
		pathTempNodes := self relation source calculatePathTo: self relation destination useLCA: self relation useLCA checkForSpecialCase: self relation relationOptions checkForSpecialCase.
	] ifFalse: [
		self relation interpolateCurvePoints ifTrue: [
			pathTempNodes := self relation notInterpolatedCurvePoints.
		] ifFalse: [
			^self
		].
	].

	"extract point list"
	pathPoints := OrderedCollection new.
	pathTempNodes do: [ :node |
		pathPoints add: (node x @ node y).
	].

	interpolatedPoints := OrderedCollection new.
	interpolatedPoints := self relation interpolatePoints: pathPoints.
	tempT := self relation relationOptions t.
	self relation relationOptions t: 0.
	directLinePoints := OrderedCollection new.
	directLinePoints := self relation interpolatePoints: pathPoints.
	self relation relationOptions t: tempT.
	
	"direct Line"
	self directLine ifNil: [
		self directLine: (LineMorph
				from: (pathTempNodes first x)@(pathTempNodes first y)
				to: (pathTempNodes last x)@(pathTempNodes last y)
				color: Color darkGray
				width: 1).
		aMorph addMorph: self directLine.
	].
	self directLine
		verticesAt: 1 put: (pathTempNodes first x)@(pathTempNodes first y);
		verticesAt: 2 put: (pathTempNodes last x)@(pathTempNodes last y).
	
	"interpolatedLine"
	self interpolatedLine ifNil: [
		self interpolatedLine: PolygonMorph new.
			aMorph addMorph: self interpolatedLine.
		].
	self interpolatedLine
		setVertices: interpolatedPoints;
		makeOpen;
		borderWidth: 1;
		borderColor: Color darkGray.
	
	"pathLine"
	self pathLine ifNil: [
		self pathLine: PolygonMorph new.
			aMorph addMorph: self pathLine.
		].
	self pathLine
		setVertices: pathPoints;
		makeOpen;
		borderWidth: 1;
		borderColor: Color darkGray.
	
	"crossLines"
	self crossLines ifNil: [
		self crossLines: OrderedCollection new.
		1 to: pathTempNodes size do: [ :i |
			self crossLines add: (LineMorph new).
			aMorph addMorph: self crossLines last.
		].
	].
	1 to: pathTempNodes size do: [ :i |
		(self crossLines at: i)
			verticesAt: 1 put: ((pathPoints at: i) x)@((pathPoints at: i) y);
			verticesAt: 2 put: ((directLinePoints at: i) x)@((directLinePoints at: i) y);
			borderColor: Color darkGray;
			borderWidth: 1.
	].
	
	size := 10.
	"directLineNodes"
	self directLineNodes ifNil: [
		self directLineNodes: OrderedCollection new.
		1 to: directLinePoints size do: [ :i |
			self directLineNodes add: (CircleMorph new).
			aMorph addMorph: self directLineNodes last.
		].
	].
	1 to: directLinePoints size do: [ :i |
		(self directLineNodes at: i)
			bounds: (Rectangle
				origin: ((((directLinePoints at: i) x)@((directLinePoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].
		
	"interpolatedNodes"
	self interpolatedNodes ifNil: [
		self interpolatedNodes: OrderedCollection new.
		1 to: interpolatedPoints size do: [ :i |
			self interpolatedNodes add: (CircleMorph new).
			aMorph addMorph: self interpolatedNodes last.
		].
	].
	1 to: interpolatedPoints size do: [ :i |
		(self interpolatedNodes at: i)
			bounds: (Rectangle
				origin: ((((interpolatedPoints at: i) x)@((interpolatedPoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].
		
	"pathNodes"
	self pathNodes ifNil: [
		self pathNodes: OrderedCollection new.
		1 to: pathPoints size do: [ :i |
			self pathNodes add: (CircleMorph new).
			aMorph addMorph: self pathNodes last.
		].
	].
	1 to: pathPoints size do: [ :i |
		(self pathNodes at: i)
			bounds: (Rectangle
				origin: ((((pathPoints at: i) x)@((pathPoints at: i) y)) - (((size)@(size))/2)) 
				extent: ((size)@(size)));
			color: Color white;
			borderColor: Color darkGray;
			borderWidth: 1.
	].! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:24'!
drawOn: aMorph

	self abandon.
	self relation relationOptions showInterpolationOverlay ifTrue: [
		self drawNewOn: aMorph.
	].
	! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
interpolatedLine
	"Answer the value of interpolatedLine"

	^ interpolatedLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
interpolatedLine: anObject
	"Set the value of interpolatedLine"

	interpolatedLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
interpolatedNodes
	"Answer the value of interpolatedNodes"

	^ interpolatedNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:45'!
interpolatedNodes: anObject
	"Set the value of interpolatedNodes"

	interpolatedNodes := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathLine
	"Answer the value of pathLine"

	^ pathLine! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathLine: anObject
	"Set the value of pathLine"

	pathLine := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathNodes
	"Answer the value of pathNodes"

	^ pathNodes! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/26/2012 18:24'!
pathNodes: anObject
	"Set the value of pathNodes"

	pathNodes := anObject! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
relation
	"Answer the value of relation"

	^ relation! !

!InterpolationOverlay methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:30'!
relation: anObject
	"Set the value of relation"

	relation := anObject! !

!InterpolationOverlay methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 17:36'!
setRelation: aRelation
	self relation: aRelation.
	aRelation interpolationOverlay: self.! !

Object subclass: #Node
	instanceVariableNames: 'children parent relations weight x y size nodeRepresentation lineRepresentations label labelRepresentation transparency isHighlighted highlightedHierarchicalLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Node commentStamp: 'CR 10/19/2012 10:33' prior: 0!
A Node is a part of a graph data structure. It knows its parent and its children as well of all relations that connect the node to an other node.

Instance Variables
	children:		<Object>
	parent:		<Object>
	relations:		<Object>

children
	- xxxxx

parent
	- xxxxx

relations
	- xxxxx
!

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:59'!
abandonAll
	"recursively dispose all morph objects for this graph"
	self children do: [ :child |
		child abandonAll.
	].
	ShapeRenderer abandonNode: self.
	ShapeRenderer abandonHierarchicalLinesFor: self.
	self relations do: [:relation | relation abandon.].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:11'!
addChild: aChild
	children add: aChild.
	aChild parent: self.! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:29'!
addRelation: aRelation
	relations add: aRelation.! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 1/7/2013 19:34'!
calculateFDEB
	(RelationLayouterFDEB initializeWithAllRelations: self getAllRelations) calculateLayout.
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:40'!
calculateNumberOfLeafs
	"calculate the number of leaf nodes in this (sub-)tree."
	| numberOfLeafs |
	numberOfLeafs := 0.
	self children
		ifEmpty: [numberOfLeafs := 1]
		ifNotEmpty: [self children do: [ :child | numberOfLeafs := numberOfLeafs + child calculateNumberOfLeafs]].
	^numberOfLeafs! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 14:51'!
calculatePathTo: otherNode
	^self calculatePathTo: otherNode useLCA: true checkForSpecialCase: true.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:19'!
calculatePathTo: otherNode useLCA: includeLCA checkForSpecialCase: checkForSpecialCase
	| path myParent otherParent myList otherList |
	myParent := self.
	otherParent := otherNode.
	myList := OrderedCollection new.
	otherList := OrderedCollection new.

	"bring nodes to same depth"
	((myParent depth) > (otherParent depth)) ifTrue: [
		((myParent depth) - (otherParent depth)) timesRepeat: [
			myList add: myParent.
			myParent := myParent parent.
		].
	].
	((myParent depth) < (otherParent depth)) ifTrue: [
		((otherParent depth) - (myParent depth)) timesRepeat: [
			otherList add: otherParent .
			otherParent := otherParent parent.
		].
	].

	"go up one level of depth until parents are the same"
	[myParent ~~ otherParent]
	whileTrue: 
	[
		myList add: myParent.
		otherList add: otherParent .
		myParent := myParent parent.
		otherParent := otherParent parent.
	] 
	.
	(includeLCA) ifTrue: [
		myList add: myParent.
	] ifFalse: [
		(checkForSpecialCase & ((myList size + otherList size) < 3)) ifTrue: [
			myList add: myParent.
		].
	].
	
	path := myList.
	path addAllLast: (otherList reversed).
	^path.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 09:57'!
calculateRadialTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	self 
		calculateRadialTreeLayoutAtPoint: rootPoint 
		startAngle: 0 
		endAngle: 2 * 3.1415
		nodeSize: nodeSize 
		nodePadding: nodePadding 
		layerDistance: layerDistance 
		totalNumberOfLeafs: (self calculateNumberOfLeafs).
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:01'!
calculateRadialTreeLayoutAtPoint: rootPoint startAngle: startAngle endAngle: endAngle nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance totalNumberOfLeafs: totalNumberOfLeafs
	"."
	| abc angle anglePerLeaf childStartAngle childEndAngle |
	angle := (startAngle + endAngle) / 2.
	self x: angle sin * (self depth - 1) * layerDistance + rootPoint x.
	self y: angle cos * (self depth - 1) * layerDistance + rootPoint y.
	self size: nodeSize.
	
	anglePerLeaf := (endAngle - startAngle) / totalNumberOfLeafs.
	childStartAngle := startAngle.
	self children do: [ :child | 
		abc := 0.
		childEndAngle := childStartAngle + (anglePerLeaf * (child calculateNumberOfLeafs)).
		child 
			calculateRadialTreeLayoutAtPoint: rootPoint 
			startAngle: childStartAngle
			endAngle: childEndAngle
			nodeSize: nodeSize
			nodePadding: nodePadding 
			layerDistance: layerDistance 
			totalNumberOfLeafs: (child calculateNumberOfLeafs).
		childStartAngle := childEndAngle.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 15:46'!
calculateRootedTreeLayoutAtPoint: rootPoint nodeSize: nodeSize nodePadding: nodePadding layerDistance: layerDistance
	"."
	| childLeft length childX childY |
	self x: rootPoint x.
	self y: rootPoint y.
	self size: nodeSize.

	length := (nodeSize + nodePadding) * self calculateNumberOfLeafs.
	childLeft := rootPoint x - (length / 2).
	
	childX := childLeft.
	childY := rootPoint y + layerDistance.
	
	self children do: [ :child | 
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
		child calculateRootedTreeLayoutAtPoint: (childX@childY) 
			nodeSize: nodeSize 
			nodePadding: nodePadding 
			layerDistance: layerDistance.
		childX := childX + ((nodeSize + nodePadding) * child calculateNumberOfLeafs /2).
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 10/21/2012 16:12'!
calculateWeight
	"calculate the weight of this node depending on the weight of the children"

	| calculatedWeight |
	calculatedWeight := 0.
	self children
		ifEmpty: [calculatedWeight := self weight]
		ifNotEmpty: [self children do: [ :child | calculatedWeight := calculatedWeight + child calculateWeight]].
	self weight: calculatedWeight.
	^calculatedWeight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:24'!
children
	^children! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
children: anObject
	"Set the value of children"

	children := anObject! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:07'!
copy
	"recursively copies the current tree"
	| myCopy |
	myCopy := self class new.
	self children do: [ :child |
		myCopy addChild: child copy.
	].
	^myCopy.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:37'!
depth
	self isRoot
		ifTrue: [^1]
		ifFalse: [^1 + parent depth].! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 11/30/2012 19:27'!
do: aBlock
	"recursively applies the given block"
	aBlock value: self.
	self children do: [ :child |
		child do: aBlock.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 14:05'!
drawHierarchyLinesOn: aMorph
	"recursively draws all parent-child-relations in its subtree as circles"
	self children do: [ :child |
		child drawHierarchyLinesOn: aMorph.
	].
	ShapeRenderer drawHierarchyLinesFor: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 13:21'!
drawNodesOn: aMorph
	"recursively draws all nodes in its subtree as circles"
	self children do: [ :child |
		child drawNodesOn: aMorph.
	].	
	ShapeRenderer drawNode: self On: aMorph.
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 20:54'!
drawRelationsOn: aMorph
	"recursively draws all relations in its subtree as circles"
	self relations do: [ :relation |
		relation relationOptions useHierarchicalEdgeBundles ifTrue: [
		relation calculateHEBCurveForPath: (self calculatePathTo: relation destination useLCA: relation useLCA checkForSpecialCase: relation relationOptions checkForSpecialCase)].
		relation drawOn: aMorph.
	].
	self children do: [ :child |
		child drawRelationsOn: aMorph.
	].
	^self.! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 20:52'!
drawWithLinesOn: aMorph

	self getAllRelations ifNotEmpty: [
		self getAllRelations first relationOptions useHierarchicalEdgeBundles ifFalse: [
			self calculateFDEB]].	
	self drawRelationsOn: aMorph;
		drawHierarchyLinesOn: aMorph;
		drawNodesOn: aMorph.
	^self.! !

!Node methodsFor: 'accessing' stamp: 'CR 1/5/2013 17:09'!
getAllRelations
	| tempRelations |
	tempRelations := OrderedCollection new.
	self children do: [:child |
		tempRelations addAllLast: child getAllRelations.].
	tempRelations addAllLast: self relations.
	^tempRelations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:59'!
getMaxDepth
	"get depth of the whole (sub-)tree."
	| maxDepthOfChildren |
	maxDepthOfChildren := children inject: 0 into: [:prev :child | (prev > child getMaxDepth)
		ifTrue: [prev]
		ifFalse: [child getMaxDepth]].
	^ maxDepthOfChildren + 1.
! !

!Node methodsFor: 'accessing' stamp: 'SL 1/5/2013 18:45'!
getRoot
	self parent ifNotNil: [
		^self parent getRoot.
	] ifNil: [
		^self.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 16:00'!
hasAncestor: aNode
	self parent ifNil: [
		^false.
	].

	(self parent == aNode) ifTrue: [
		^true.
	] ifFalse: [
		^self parent hasAncestor: aNode.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:45'!
highlightHierarchyLineTo: aNode
	"highlights the line between self and the parent node"
	(self children includes: aNode) ifTrue: [
		self highlightedHierarchicalLines add: aNode.
	] ifFalse: [
		aNode highlightHierarchyLineTo: self.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 14:44'!
highlightPathTo: aNode
	"highlights all nodes and hierarchical relations to aNode"
	| nodePath |
	nodePath := self calculatePathTo: aNode.
	2 to: (nodePath size) do: [ :i | (nodePath at: (i-1)) highlightHierarchyLineTo: (nodePath at: i). ].
	nodePath do: [:node | node isHighlighted: true. ].! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines
	"Answer the value of highlightedHierarchicalLines"

	^ highlightedHierarchicalLines! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
highlightedHierarchicalLines: anObject
	"Set the value of highlightedHierarchicalLines"

	highlightedHierarchicalLines := anObject! !

!Node methodsFor: 'initializing' stamp: 'SL 12/24/2012 15:27'!
initialize
	super initialize.
	weight := 1.
	isHighlighted := false.
	children := OrderedCollection new.
	relations := OrderedCollection new.
	lineRepresentations := Dictionary new.
	highlightedHierarchicalLines := OrderedCollection new.! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted
	"Answer the value of isHighlighted"

	^ isHighlighted! !

!Node methodsFor: 'accessing' stamp: 'SL 12/24/2012 15:07'!
isHighlighted: anObject
	"Set the value of isHighlighted"

	isHighlighted := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:26'!
isLeaf
	^ children isEmpty.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:07'!
isRoot
	^ parent isNil.! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label
	"Answer the value of label"

	^ label! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
label: anObject
	"Set the value of label"

	label := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation
	"Answer the value of labelRepresentation"

	^ labelRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/30/2012 20:46'!
labelRepresentation: anObject
	"Set the value of labelRepresentation"

	labelRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations
	"Answer the value of lineRepresentations"

	^ lineRepresentations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:36'!
lineRepresentations: anObject
	"Set the value of lineRepresentations"

	lineRepresentations := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation
	"Answer the value of nodeRepresentation"

	^ nodeRepresentation! !

!Node methodsFor: 'accessing' stamp: 'SL 11/9/2012 11:40'!
nodeRepresentation: anObject
	"Set the value of nodeRepresentation"

	nodeRepresentation := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:13'!
parent
	"Answer the value of parent"

	^ parent! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:14'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 1/5/2013 22:14'!
position
	^x@y! !

!Node methodsFor: 'accessing' stamp: 'CR 1/8/2013 20:19'!
position: aPoint
	self x: aPoint x.
	self y: aPoint y.! !

!Node methodsFor: 'accessing' stamp: 'CR 1/8/2013 20:53'!
positionOfNodeMorph
	^nodeRepresentation bounds origin + (self size/2)! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:30'!
relations
	^relations! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
relations: anObject
	"Set the value of relations"

	relations := anObject! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:57'!
resetAllHighlighting
	self isHighlighted: false.
	self children do: [ :child |
		child resetAllHighlighting.
	].
	self highlightedHierarchicalLines: OrderedCollection new.
! !

!Node methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:11'!
resetAllLabels
	self label: ''.
	self children do: [ :child |
		child resetAllLabels.
	].
! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:56'!
setTransparency: aTransparency
	"recursively set the given transparency for whole (sub-)tree"
	self do: [ :node |
		node transparency: aTransparency.
		node children do: [ :relation | relation relationOptions transparency: aTransparency ].
	].
	^self.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:28'!
size
	^size! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 17:27'!
size: anObject
	"Set the value of size"

	size := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!Node methodsFor: 'accessing' stamp: 'SL 12/1/2012 14:54'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight
	^weight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight: aNumber
	weight := aNumber.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x
	"Answer the value of x"

	^ x! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
x: anObject
	"Set the value of x"

	x := anObject! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y
	"Answer the value of y"

	^ y! !

!Node methodsFor: 'accessing' stamp: 'SL 10/21/2012 16:30'!
y: anObject
	"Set the value of y"

	y := anObject! !

Object subclass: #Relation
	instanceVariableNames: 'source destination tesselatedPoints t useLCA interpolateControlPoints interpolateCurvePoints representation transparency interpolationOverlay notInterpolatedCurvePoints subdivisionPoints relationOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Relation commentStamp: 'CR 10/19/2012 10:34' prior: 0!
A Relation describes an usally non hierarchical connection between two nodes.

Instance Variables
	destination:		<Object>
	source:		<Object>

destination
	- xxxxx

source
	- xxxxx
!

!Relation methodsFor: 'drawing' stamp: 'SL 12/25/2012 13:50'!
abandon
	ShapeRenderer abandonRelation: self.! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:24'!
calculateBSpline: hullPoints
	"showcase for drawing a bSpline using Matrix calculation."
	
	self tesselatedPoints: OrderedCollection new.
	-2 to: (hullPoints size) do: [ :i |
	self tesselatedPoints addAllLast: (self calculateLineWithP1: 
		(hullPoints at: ((i max: 1) min: (hullPoints size)))
		p2: (hullPoints at: (((i + 1) max: 1) min: (hullPoints size)))
		p3: (hullPoints at: (((i + 2) max: 1) min: (hullPoints size)))
		p4: (hullPoints at: (((i + 3) max: 1) min: (hullPoints size))) 
		div: 10).		
	].! !

!Relation methodsFor: 'drawing' stamp: 'CR 1/5/2013 17:23'!
calculateHEBCurve: aPointList
	"calculates the tesselatedPoints from the given control points"
	| interpolatedControlPoints |
	tesselatedPoints := OrderedCollection new.
	(self interpolateControlPoints) 
		ifTrue: [	interpolatedControlPoints := (self interpolatePoints: aPointList).]
		ifFalse: [interpolatedControlPoints := aPointList.].
	(interpolatedControlPoints size = 3)
		ifTrue: [self calculateQuadraticBezier: interpolatedControlPoints.]
		ifFalse: [self calculateBSpline: interpolatedControlPoints].
	self notInterpolatedCurvePoints: self tesselatedPoints.
	(self interpolateCurvePoints)
		ifTrue: [self tesselatedPoints: (self interpolatePoints: (self tesselatedPoints))].! !

!Relation methodsFor: 'drawing' stamp: 'CR 1/5/2013 17:25'!
calculateHEBCurveForPath: aNodeList
	| pointList |
	"extracts points from given list of nodes"
	pointList := OrderedCollection new.
	aNodeList do: [ :node | 
		pointList add: (node x)@(node y).
	].
	self calculateHEBCurve: pointList.
	^self.
! !

!Relation methodsFor: 'drawing' stamp: 'CR 10/23/2012 15:19'!
calculateLineWithP1: p1 p2: p2 p3: p3 p4: p4 div: divisions
	"matrix magic to compute bspline"
	| spline a0 a1 a2 a3 b0 b1 b2 b3 t |
	a0 := ((p1 x * -1) + (p2 x * 3) - (3 * (p3 x)) + (p4 x)) / 6.
	a1 := ((3 * (p1 x)) - (6 * (p2 x)) + (3 * (p3 x))) / 6.
	a2 := ((-3 * (p1 x)) + (3 * (p3 x))) / 6.
	a3 := ((p1 x) + (4 * (p2 x)) + (p3 x)) / 6.
	b0 := ((-1 * (p1 y)) + (3 * (p2 y)) - (3 * (p3 y)) + (p4 y)) / 6.
	b1 := ((3 * (p1 y)) - (6 * (p2 y)) + (3 * (p3 y))) / 6.
	b2 := ((-3 * (p1 y)) + (3 * (p3 y))) / 6.
	b3 := ((p1 y) + (4 * (p2 y)) + (p3 y)) / 6.
	spline := OrderedCollection with: a3@b3.
	1 to: (divisions) do: [:i | 
		t := i / divisions.
		spline add:
			(a3 + (t * (a2 + (t * (a1 + (t * a0))))))
			@
			(b3 + (t * (b2 + (t * (b1 + (t * b0)))))).	
	].
	^spline.! !

!Relation methodsFor: 'drawing' stamp: 'SL 10/24/2012 10:42'!
calculateQuadraticBezier: aPointList

	| bernstein0 bernstein1 bernstein2 calculatedPoint step amountOfSteps t|
	amountOfSteps := 10.
	self tesselatedPoints add: (aPointList at: 1).
	(aPointList size = 3) ifTrue: [
		step := 1 / (amountOfSteps - 1).
		2 to: (amountOfSteps - 1) do: [ :i |
			t := i * step.
			bernstein0 := (1 - t) * (1 - t).
			bernstein1 := 2 * t * (1 - t).
			bernstein2 := t * t.
			calculatedPoint := (aPointList at: 1) * bernstein0.
			calculatedPoint := calculatedPoint + ((aPointList at: 2) * bernstein1).
			calculatedPoint := calculatedPoint + ((aPointList at: 3) * bernstein2).
			self tesselatedPoints add: calculatedPoint.
		]].! !

!Relation methodsFor: 'as yet unclassified' stamp: 'SL 1/8/2013 10:44'!
calculateSubdivisionPoints: numberOfSubdivisionPoints
	| totalLength dividedLength |
	totalLength := 0.
	2 to: self tesselatedPoints size do: [ :i | |distance|
		distance := (self tesselatedPoints at: (i - 1)) dist: (self tesselatedPoints at: i).
		totalLength := totalLength + distance.
	].
	dividedLength := totalLength / (numberOfSubdivisionPoints + 1).
	
	self subdivisionPoints: (OrderedCollection with: self tesselatedPoints first).
	1 to: numberOfSubdivisionPoints do: [ :i | | currentPointTotalLength tesselatedPointLength tesselatedPointIndex difference segmentDistance t |
		currentPointTotalLength := i * dividedLength.
		tesselatedPointLength := 0.
		tesselatedPointIndex := 1.
		[currentPointTotalLength > tesselatedPointLength] whileTrue: [
			tesselatedPointLength := tesselatedPointLength + (
				(self tesselatedPoints at: tesselatedPointIndex) dist:
				(self tesselatedPoints at: (tesselatedPointIndex +1))).
			tesselatedPointIndex := tesselatedPointIndex + 1.
		].
		difference := tesselatedPointLength - currentPointTotalLength.
		segmentDistance := (self tesselatedPoints at: tesselatedPointIndex) dist:
			(self tesselatedPoints at: (tesselatedPointIndex - 1)).
		t := difference / segmentDistance.
		self subdivisionPoints addLast: (
			((1-t) * (self tesselatedPoints at: tesselatedPointIndex)) +
			(t * (self tesselatedPoints at: (tesselatedPointIndex - 1)))
		).
	].
	self subdivisionPoints addLast: self tesselatedPoints last.
	
	"newer stuff, but old"
	"| oldSubdivisionPoints newSubdivisionPoints oldNumberOfSegments newNumberOfSegments |"
	"initialize temporary variables"
	"oldSubdivisionPoints := self tesselatedPoints.
	oldNumberOfSegments := oldSubdivisionPoints size - 1.
	newNumberOfSegments := numberOfSubdivisionPoints + 1.
	newSubdivisionPoints := OrderedCollection with: oldSubdivisionPoints first.
	
	1 to: numberOfSubdivisionPoints do: [ :i | | rational ganzzahl kommazahl p0 p1 newP |
		rational := oldNumberOfSegments / newNumberOfSegments.
		ganzzahl := rational truncated.
		kommazahl := rational - ganzzahl.
		p0 := oldSubdivisionPoints at: (ganzzahl + 1).
		p1 := oldSubdivisionPoints at: (ganzzahl + 2).
		newP := (p1 * kommazahl) + (p0 * (1.0 - kommazahl )).
		newSubdivisionPoints addLast: newP.
	].
	newSubdivisionPoints addLast: oldSubdivisionPoints last.
	self subdivisionPoints: newSubdivisionPoints."

	"old stuff"
	"maybe add the counter always starts at the same site"
	"| lengthOfLineSegment source destination |
	self subdivisionPoints: OrderedCollection new.
	source := (self source x)@(self source y).
	destination := (self destination x)@(self destination y).
	lengthOfLineSegment := (source dist: destination)/(numberOfSubdivisionPoints +1).
	(1 to: numberOfSubdivisionPoints) do: [:i | | pi |
		pi := source + (lengthOfLineSegment * (((destination x - source y)@(destination y - source y)) normalized)).
		self subdivisionPoints addLast: pi.]"! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
destination
	"Answer the value of destination"

	^ destination! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
destination: anObject
	"Set the value of destination"

	destination := anObject! !

!Relation methodsFor: 'drawing' stamp: 'SL 12/24/2012 14:54'!
drawOn: aMorph
	ShapeRenderer drawRelation: self On: aMorph.
! !

!Relation methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:21'!
initialize
	super initialize.! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:12'!
interpolateControlPoints
	"Answer the value of interpolateControlPoints"

	^ self relationOptions interpolateControlPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
interpolateControlPoints: anObject
	"Set the value of interpolateControlPoints"

	interpolateControlPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:12'!
interpolateCurvePoints
	"Answer the value of interpolateCurvePoints"

	^ self relationOptions interpolateCurvePoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
interpolateCurvePoints: anObject
	"Set the value of interpolateCurvePoints"

	interpolateCurvePoints := anObject! !

!Relation methodsFor: 'drawing' stamp: 'CR 12/28/2012 11:24'!
interpolatePoints: aPointList
	"interpolate given point list"
	| interpolatedList first last t |
	t := self relationOptions t.
	first := aPointList first.
	last := aPointList last.
	interpolatedList := OrderedCollection with: first.
	2 to: (aPointList size - 1) do: [ :i |
		interpolatedList add:
			(((aPointList at: i) * t) + 
			((1 - t) * (first + (((i-1) / (aPointList size - 1)) * (last - first))))).
	].
	interpolatedList add: last.
	^interpolatedList.! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:36'!
interpolationOverlay
	"Answer the value of interpolationOverlay"

	^ interpolationOverlay! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/25/2012 17:36'!
interpolationOverlay: anObject
	"Set the value of interpolationOverlay"

	interpolationOverlay := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/26/2012 17:48'!
notInterpolatedCurvePoints
	"Answer the value of notInterpolatedCurvePoints"

	^ notInterpolatedCurvePoints! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/26/2012 17:48'!
notInterpolatedCurvePoints: anObject
	"Set the value of notInterpolatedCurvePoints"

	notInterpolatedCurvePoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:20'!
relationOptions
	"Answer the value of relationOptions"
	relationOptions ifNil: [
		self relationOptions: RelationOptions new.
	].
	^ relationOptions! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:02'!
relationOptions: anObject
	"Set the value of relationOptions"

	relationOptions := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation
	"Answer the value of representation"

	^ representation! !

!Relation methodsFor: 'accessing' stamp: 'SL 12/1/2012 15:24'!
representation: anObject
	"Set the value of representation"

	representation := anObject! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/23/2012 15:47'!
setSource: sourceNode andDestination: destinationNode
	sourceNode addRelation: self.
	source := sourceNode.
	destination := destinationNode.
	^self.! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
source
	"Answer the value of source"

	^ source! !

!Relation methodsFor: 'accessing' stamp: 'SL 10/24/2012 14:22'!
source: anObject
	"Set the value of source"

	source := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
subdivisionPoints
	"Answer the value of subdivisionPoints"

	^ subdivisionPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
subdivisionPoints: anObject
	"Set the value of subdivisionPoints"

	subdivisionPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:29'!
t
	"Answer the value of interpolateControlPoints"

	^ self relationOptions t.! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
t: anObject
	"Set the value of t"

	t := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints
	"Answer the value of tesselatedPoints"

	^ tesselatedPoints! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/23/2012 15:02'!
tesselatedPoints: anObject
	"Set the value of tesselatedPoints"

	tesselatedPoints := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:11'!
transparency
	"Answer the value of transparency"

	^ self relationOptions transparency.! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:11'!
useLCA
	"Answer the value of useLCA"

	^ self relationOptions useLCA.! !

!Relation methodsFor: 'accessing' stamp: 'CR 1/5/2013 18:36'!
useLCA: anObject
	"Set the value of useLCA"

	useLCA := anObject! !

Object subclass: #RelationLayouterFDEB
	instanceVariableNames: 'allRelations relationOptions k'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!RelationLayouterFDEB class methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:33'!
initializeWithAllRelations: allRelations
	"initialize layouter instance"
	allRelations ifEmpty: [
		^self initializeWithAllRelations: allRelations AndRelationOptions: RelationOptions new.		
	] ifNotEmpty: [
		^self initializeWithAllRelations: allRelations AndRelationOptions: allRelations first relationOptions.
	].
	! !

!RelationLayouterFDEB class methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:34'!
initializeWithAllRelations: allRelations AndRelationOptions: aRelationOptions
	"initialize layouter instance"
	| newLayouter |
	newLayouter := self new.
	newLayouter
		allRelations: allRelations;
		relationOptions: aRelationOptions;
		k: 0.1.
	^newLayouter! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'CR 1/7/2013 19:23'!
allRelations
	"Answer the value of allRelations"

	^ allRelations! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'CR 1/7/2013 19:23'!
allRelations: anObject
	"Set the value of allRelations"

	allRelations := anObject! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:42'!
calculateAngleCompabilityFor: p And: q
	| vectorP vectorQ |
	self relationOptions useAngleMeasurement ifTrue: [
		vectorP := p destination position - p source position.
		vectorQ := q destination position - q source position.
		^((vectorP dotProduct: vectorQ) / (((0@0) dist: vectorP) * ((0@0) dist: vectorQ))) abs.
	].
	^1.0
! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/8/2013 20:27'!
calculateCompabilityFor: aRelation And: anotherRelation
	^(self calculateAngleCompabilityFor: aRelation And: anotherRelation) *
	(self calculateScaleCompabilityFor: aRelation And: anotherRelation) *
	(self calculatePositionCompabilityFor: aRelation And: anotherRelation) *
	(self calculateVisibilityCompabilityFor: aRelation And: anotherRelation).! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:37'!
calculateLayout
	"initialize tesselated points"
	self allRelations do: [:relation |
		relation tesselatedPoints: (OrderedCollection 
			with: relation source position 
			with: relation destination position).
	].

	self
		computeCycles: self relationOptions startComputeCycles
		WithNumberOfSubdivisionPoints: self relationOptions startNumberOfSubdivisionPoints
		IterationSteps: self relationOptions startIterationSteps
		AndStepSize: self relationOptions startStepSize.
	^self! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:43'!
calculatePositionCompabilityFor: p And: q
	| distancePQ middlePointP middlePointQ averageLength lengthP lengthQ |
	self relationOptions usePositionMeasurement ifTrue: [
		middlePointP := (p source position + p destination position) / 2.
		middlePointQ := (q source position + q destination position) / 2.
		distancePQ := (middlePointP dist: middlePointQ).
	
		lengthP := (p source position dist: p destination position).
		lengthQ := (q source position dist: q destination position).
		averageLength := (lengthP + lengthQ) / 2.
	
		^averageLength / (averageLength + (distancePQ*0.1)).
	].
	^1.0
	
! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:44'!
calculateScaleCompabilityFor: p And: q
	| lengthP lengthQ |
	self relationOptions useScaleMeasurement ifTrue: [
		lengthP := (p source position dist: p destination position).
		lengthQ := (q source position dist: q destination position).
		(0 = lengthP) ifTrue: [lengthP := 1].
		(0 = lengthQ) ifTrue: [lengthQ := 1].
		^(lengthP / lengthQ ) min: (lengthQ / lengthP ).
	].
	^1.0! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:45'!
calculateVisibilityCompabilityFor: p And: q
	self relationOptions usePositionMeasurement ifTrue: [
		^(self getVisibilityFor: p And: q) min: (self getVisibilityFor: q And: p).
	].
	^1.0! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'CR 1/7/2013 22:11'!
computeCycles: cyclesLeft WithNumberOfSubdivisionPoints: numberOfSubdivisionPoints IterationSteps: iterationSteps AndStepSize: stepSize
	cyclesLeft <= 0 ifTrue: [^self].
	
	"for each cycle"
	self updateSubdivisionPointsTo: numberOfSubdivisionPoints.
	
	iterationSteps timesRepeat: [
		"build subdivision points"
		self allRelations do: [:relation | | correspondingRelationsDict |
			correspondingRelationsDict := self getCorrespondingRelationsFor: relation.
			2 to: (relation subdivisionPoints size -1) do: [ :i | | kp fe totalForce |
				kp := self k / (relation subdivisionPoints size - 1).
				totalForce := kp * (
					(relation subdivisionPoints at: (i - 1)) - 
					relation subdivisionPoints at: i).
				totalForce := totalForce + (kp * (
					(relation subdivisionPoints at: (i + 1)) -
					relation subdivisionPoints at: i)).
				fe := (0.0@0.0).
				correspondingRelationsDict keysAndValuesDo: [ :otherRelation :c | | q p vector |
					q := otherRelation subdivisionPoints at: i.
					p := relation subdivisionPoints at: i.
					vector := q - p.
					fe := fe + (c / (vector dist: (0.0@0.0)) * vector).
				].
				totalForce := totalForce + fe.
				relation subdivisionPoints at: i put: (
					(relation subdivisionPoints at: i) + totalForce).
			].
		].

	].

	"apply subdivision points as tesselated points"
	self allRelations do: [:relation |
		relation tesselatedPoints: relation subdivisionPoints.
	].

	"call method recursive"
	self 
		computeCycles: cyclesLeft - 1
		WithNumberOfSubdivisionPoints: numberOfSubdivisionPoints * 2
		IterationSteps: (iterationSteps * 2 / 3) truncated
		AndStepSize: stepSize / 2.! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 21:55'!
getCorrespondingRelationsFor: aRelation
	| relationDict |
	relationDict := Dictionary new.
	self allRelations do: [ :relation |
		aRelation ~~ relation ifTrue: [
			"check if compatibility fits the given requirements"
			self relationOptions useCompatibilityMeasurement ifTrue: [ | gradeOfCompatibility |
				gradeOfCompatibility := self calculateCompabilityFor: aRelation And: relation.
				(self relationOptions treshholdCompatibility < gradeOfCompatibility) ifTrue: [
					relationDict at: relation put: (gradeOfCompatibility).
				].
			] ifFalse: [
				relationDict at: relation put: (1.0).
			].
		].
	].
	^relationDict.! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/8/2013 22:35'!
getI0I1ImFor: p And: q
	| x1 y1 x2 y2 x3 y3 x4 y4 normalVectorQ vectorQ i1x underTheScore i1y i0x i0y i0 i1 im |
	vectorQ := p destination position - p source position.
	normalVectorQ := vectorQ normal.
	x1 := p source position x.
	y1 := p source position y.
	x2 := p destination position x.
	y2 := p destination position y.
	x3 := q source position x.
	y3 := q source position y.
	x4 := x3 + normalVectorQ x.
	y4 := y3 + normalVectorQ y.
	"check for parallel lines"
	"(0 = (()()()()()()()) ifTrue: [^0.0]."
	underTheScore := ((x1-x2)*(y3-y4))-((y1-y2)*(x3-x4)).
	i0x := ((((x1*y2)-(y1*x2)*(x3-x4)) - ((x1-x2)*((x3*y4)-(x4*y3)))) /
		underTheScore).
	i0y := ((((x1*y2)-(y1*x2)*(y3-y4)) - ((y1-y2)*((x3*y4)-(x4*y3)))) /
		underTheScore).
	x3 := q destination position x.
	y3 := q destination position y.
	x4 := x3 + normalVectorQ x.
	y4 := y3 + normalVectorQ y.
	underTheScore := ((x1-x2)*(y3-y4))-((y1-y2)*(x3-x4)).
	i1x := ((((x1*y2)-(y1*x2)*(x3-x4)) - ((x1-x2)*((x3*y4)-(x4*y3)))) /
		underTheScore).
	i1y := ((((x1*y2)-(y1*x2)*(y3-y4)) - ((y1-y2)*((x3*y4)-(x4*y3)))) /
		underTheScore).
	i0 := i0x @ i0y.
	i1 := i1x @ i1y.
	im := (i0 + i1) / 2.	
	^OrderedCollection with: i0 with: i1 with: im.! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'SL 1/8/2013 22:41'!
getVisibilityFor: p And: q
	| middlePointP iq0 iq01m iq1 iqm |
	iq01m := self getI0I1ImFor: p And: q.
	iq0 := iq01m at: 1.
	iq1 := iq01m at: 2.
	iqm := iq01m at: 3.
	middlePointP := (p source position + p destination position) / 2.
	
	^ 0 max: (1 - ((2* (middlePointP dist: iqm)) / (iq0 dist: iq1))).! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'CR 1/7/2013 20:40'!
k
	"Answer the value of k"

	^ k! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'CR 1/7/2013 20:40'!
k: anObject
	"Set the value of k"

	k := anObject! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:26'!
relationOptions
	"Answer the value of relationOptions"

	^ relationOptions! !

!RelationLayouterFDEB methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:26'!
relationOptions: anObject
	"Set the value of relationOptions"

	relationOptions := anObject! !

!RelationLayouterFDEB methodsFor: 'as yet unclassified' stamp: 'CR 1/7/2013 20:00'!
updateSubdivisionPointsTo: numberOfSubdivisionPoints
	self allRelations do: [:relation |
		relation calculateSubdivisionPoints: numberOfSubdivisionPoints.
	].
	^self! !

Object subclass: #RelationOptions
	instanceVariableNames: 't useLCA checkForSpecialCase interpolateControlPoints interpolateCurvePoints transparency showInterpolationOverlay borderColor useHierarchicalEdgeBundles springStrengthK useCompatibilityMeasurement treshholdCompatibility useAngleMeasurement useScaleMeasurement usePositionMeasurement useVisibilityMeasurement startComputeCycles startNumberOfSubdivisionPoints startIterationSteps startStepSize refreshTesselatedPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:58'!
borderColor
	"Answer the value of borderColor"

	^ borderColor! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:58'!
borderColor: anObject
	"Set the value of borderColor"

	borderColor := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 12/28/2012 14:29'!
checkForSpecialCase
	"Answer the value of checkForSpecialCase"

	^ checkForSpecialCase! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 12/28/2012 14:29'!
checkForSpecialCase: anObject
	"Set the value of checkForSpecialCase"

	checkForSpecialCase := anObject! !

!RelationOptions methodsFor: 'as yet unclassified' stamp: 'SL 1/9/2013 22:02'!
initialize
	super initialize.
	self
		t: 0.85;
		useLCA: true;
		checkForSpecialCase: false;
		interpolateCurvePoints: false;
		interpolateControlPoints: true;
		showInterpolationOverlay: false;
		transparency: 0.8;
		borderColor: (Color h: 10 s: 1.0 v: 1.0 alpha: self transparency);
		
		useHierarchicalEdgeBundles: true;
		springStrengthK: 0.1;
		
		"fdeb compatibility"
		useCompatibilityMeasurement: true;
		treshholdCompatibility: 0.5;
		useAngleMeasurement: true;
		useScaleMeasurement: true;
		usePositionMeasurement: true;
		useVisibilityMeasurement: true;
		
		"manipulate physics"
		startComputeCycles: 6;
		startNumberOfSubdivisionPoints: 1;
		startIterationSteps: 50;
		startStepSize: 0.04;
		refreshTesselatedPoints: true.
! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateControlPoints
	"Answer the value of interpolateControlPoints"

	^ interpolateControlPoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateControlPoints: anObject
	"Set the value of interpolateControlPoints"

	interpolateControlPoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateCurvePoints
	"Answer the value of interpolateCurvePoints"

	^ interpolateCurvePoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
interpolateCurvePoints: anObject
	"Set the value of interpolateCurvePoints"

	interpolateCurvePoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
refreshTesselatedPoints
	"Answer the value of refreshTesselatedPoints"

	^ refreshTesselatedPoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
refreshTesselatedPoints: anObject
	"Set the value of refreshTesselatedPoints"

	refreshTesselatedPoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
showInterpolationOverlay
	"Answer the value of showInterpolationOverlay"

	^ showInterpolationOverlay! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
showInterpolationOverlay: anObject
	"Set the value of showInterpolationOverlay"

	showInterpolationOverlay := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
springStrengthK
	"Answer the value of springStrengthK"

	^ springStrengthK! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
springStrengthK: anObject
	"Set the value of springStrengthK"

	springStrengthK := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startComputeCycles
	"Answer the value of startComputeCycles"

	^ startComputeCycles! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startComputeCycles: anObject
	"Set the value of startComputeCycles"

	startComputeCycles := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startIterationSteps
	"Answer the value of startIterationSteps"

	^ startIterationSteps! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startIterationSteps: anObject
	"Set the value of startIterationSteps"

	startIterationSteps := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startNumberOfSubdivisionPoints
	"Answer the value of startNumberOfSubdivisionPoints"

	^ startNumberOfSubdivisionPoints! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startNumberOfSubdivisionPoints: anObject
	"Set the value of startNumberOfSubdivisionPoints"

	startNumberOfSubdivisionPoints := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startStepSize
	"Answer the value of startStepSize"

	^ startStepSize! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:28'!
startStepSize: anObject
	"Set the value of startStepSize"

	startStepSize := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
t
	"Answer the value of t"

	^ t! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
t: anObject
	"Set the value of t"

	t := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
transparency
	"Answer the value of transparency"

	^ transparency! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
transparency: anObject
	"Set the value of transparency"

	transparency := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
treshholdCompatibility
	"Answer the value of treshholdCompatibility"

	^ treshholdCompatibility! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
treshholdCompatibility: anObject
	"Set the value of treshholdCompatibility"

	treshholdCompatibility := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useAngleMeasurement
	"Answer the value of useAngleMeasurement"

	^ useAngleMeasurement! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useAngleMeasurement: anObject
	"Set the value of useAngleMeasurement"

	useAngleMeasurement := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useCompatibilityMeasurement
	"Answer the value of useCompatibilityMeasurement"

	^ useCompatibilityMeasurement! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useCompatibilityMeasurement: anObject
	"Set the value of useCompatibilityMeasurement"

	useCompatibilityMeasurement := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 1/5/2013 17:20'!
useHierarchicalEdgeBundles
	"Answer the value of useHierarchicalEdgeBundles"

	^ useHierarchicalEdgeBundles! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 1/5/2013 17:20'!
useHierarchicalEdgeBundles: anObject
	"Set the value of useHierarchicalEdgeBundles"

	useHierarchicalEdgeBundles := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
useLCA
	"Answer the value of useLCA"

	^ useLCA! !

!RelationOptions methodsFor: 'accessing' stamp: 'CR 12/28/2012 10:59'!
useLCA: anObject
	"Set the value of useLCA"

	useLCA := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
usePositionMeasurement
	"Answer the value of usePositionMeasurement"

	^ usePositionMeasurement! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
usePositionMeasurement: anObject
	"Set the value of usePositionMeasurement"

	usePositionMeasurement := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useScaleMeasurement
	"Answer the value of useScaleMeasurement"

	^ useScaleMeasurement! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useScaleMeasurement: anObject
	"Set the value of useScaleMeasurement"

	useScaleMeasurement := anObject! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useVisibilityMeasurement
	"Answer the value of useVisibilityMeasurement"

	^ useVisibilityMeasurement! !

!RelationOptions methodsFor: 'accessing' stamp: 'SL 1/9/2013 21:12'!
useVisibilityMeasurement: anObject
	"Set the value of useVisibilityMeasurement"

	useVisibilityMeasurement := anObject! !

Object subclass: #ShapeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:01'!
abandonHierarchicalLinesFor: aNode

	aNode lineRepresentations do: [ :representation |
		representation abandon.
	].
	aNode lineRepresentations removeAll.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonLabelFor: aNode

	(aNode labelRepresentation) ifNotNil: [
		aNode labelRepresentation abandon.
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 14:03'!
abandonNode: aNode

	aNode nodeRepresentation ifNotNil: [
		aNode nodeRepresentation abandon.
		aNode nodeRepresentation: nil.
	].
	self abandonLabelFor: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 18:43'!
abandonRelation: aRelation

	aRelation representation ifNotNil: [
		aRelation representation abandon.
		aRelation representation: nil.
	].
	aRelation interpolationOverlay ifNotNil: [
		aRelation interpolationOverlay abandon.
		aRelation interpolationOverlay: nil.
	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/26/2012 12:56'!
drawHierarchyLinesFor: aNode On: aMorph
	"draws a simple line"
	| lineRepresentation |	
	aNode children do: [ :child |
		"create circle morph, if not already done"
		(aNode lineRepresentations includesKey: child) ifFalse: [
			aNode lineRepresentations at: child put: (LineMorph
				from: (0)@(0)
				to: (0)@(0)
				color: Color darkGray
				width: 2).
				aMorph addMorph: (aNode lineRepresentations at: child).
		].

		"update lineMorph according to node attributes"
		lineRepresentation := (aNode lineRepresentations at: child).
		lineRepresentation 
			verticesAt: 1 put: ((aNode x)@(aNode y));
			verticesAt: 2 put: ((child x)@(child y)).
		"highlighting"
		(aNode highlightedHierarchicalLines includes: child) ifTrue: [
			lineRepresentation
				borderWidth: 3;
				borderColor: (Color blue darker).
		] ifFalse: [
			lineRepresentation
				borderWidth: 2;
				borderColor: Color darkGray.
		].

	].! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:15'!
drawInterpolationOverlayFor: aRelation On: aMorph

	aRelation interpolationOverlay ifNil: [
		InterpolationOverlay new setRelation: aRelation.
	].
	aRelation interpolationOverlay drawOn: aMorph.
! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:17'!
drawLabelForNode: aNode
	"draws a text next to a cirlce morph"
	(aNode label) ifNotNil: [
		"create label morph, if not already done"
		aNode labelRepresentation ifNil: [
			aNode labelRepresentation: (StringMorph contents: aNode label).		
			aNode nodeRepresentation addMorph: aNode labelRepresentation.
		].
		"update label according to node attributes"
		(aNode labelRepresentation) position: (
			(aNode size / 2 + (aNode x)) @
			(aNode size / 2 + (aNode y))
		).
		(aNode labelRepresentation) contents: aNode label.
	].

! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/26/2012 12:50'!
drawNode: aNode On: aMorph
	"create circle morph, if not already done"
	| nodeMorph |
	aNode nodeRepresentation ifNil: [
		nodeMorph := NodeMorph new.
		nodeMorph node: aNode.
		nodeMorph gui: aMorph.
		aNode nodeRepresentation: nodeMorph.
		aMorph addMorph: (aNode nodeRepresentation).
	].
	"update circle according to node attributes"
	self updateRepresentation: aNode nodeRepresentation forNode: aNode. 

	"draw the label for the node"
	self drawLabelForNode: aNode.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 21:02'!
drawPolyLine: aPointList

	| morph |
	morph := PolygonMorph new.
	morph setVertices: aPointList.
	morph borderWidth: 2.
	morph borderColor:  Color black.
	morph makeOpen.
	^morph.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 21:03'!
drawPolyLine: aPointList withWidth: width

	| morph |
	morph := PolygonMorph new.
	morph setVertices: aPointList.
	morph borderWidth: width.
	morph borderColor:  Color black.
	morph makeOpen.
	^morph.! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/28/2012 15:18'!
drawRelation: aRelation On: aMorph

	self drawInterpolationOverlayFor: aRelation On: aMorph.
	
	"create polygonmorph if not already done"
	aRelation representation ifNil: [
		aRelation representation: PolygonMorph new.
		aMorph addMorph: aRelation representation.
		aRelation representation makeOpen.
	].

	"update morph according to relation attributes"
	aRelation representation setVertices: (aRelation tesselatedPoints).
	aRelation representation borderWidth: 1.
	aRelation representation borderColor: (aRelation relationOptions borderColor alpha: aRelation relationOptions transparency). 
! !

!ShapeRenderer class methodsFor: 'as yet unclassified' stamp: 'SL 12/24/2012 15:47'!
updateRepresentation: aRepresentation forNode: aNode
	"size and position"
	aRepresentation bounds: (Rectangle
		origin: (((aNode x)@(aNode y)) - (((aNode size)@(aNode size))/2)) 
		extent: ((aNode size)@(aNode size))).
	"coloring"
	aRepresentation color: Color white.
	"highlighting"
	(aNode isHighlighted) ifTrue: [
		aRepresentation borderColor: (Color blue darker).
		aRepresentation borderWidth: 3.
	] ifFalse: [
		aRepresentation borderColor: Color darkGray.
		aRepresentation borderWidth: 1.
	].
	^aRepresentation.! !

Object subclass: #TreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 19:45'!
buildFourNodesBetweenLeft: left Right: right Bottom: bottom Top: top For: mainWindow
	"tree for the FDEB-gui"
	| root nodeP1 nodeP2 nodeQ1 nodeQ2 |
	root := Node new.
	root x: (left + (right - left)/2).
	root y: (top + (bottom - top)/2).
	root size: 20.
	nodeP1 := Node new.
	nodeP1 x: left.
	nodeP1 y: top.
	nodeP1 size: 20.
	mainWindow nodeP1: nodeP1.
	nodeP2 := Node new.
	nodeP2 x: right.
	nodeP2 y: top.
	nodeP2 size: 20.
	mainWindow nodeP2: nodeP2.
	nodeQ1 := Node new.
	nodeQ1 x: left.
	nodeQ1 y: bottom.
	nodeQ1 size: 20.
	mainWindow nodeQ1: nodeQ1. 
	nodeQ2 := Node new.
	nodeQ2 x: right.
	nodeQ2 y: bottom.
	nodeQ2 size: 20.
	mainWindow nodeQ2: nodeQ2.
	
	root addChild: nodeP1.
	root addChild: nodeP2.
	root addChild: nodeQ1.
	root addChild: nodeQ2.
	^root.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/22/2012 18:05'!
buildLargeTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node11 addChild: Node new.
	node111 addChild: Node new.
	node111 addChild: Node new.
	node112 addChild: Node new.
	node112 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node113 addChild: Node new.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node1221 addChild: Node new.
	node122 addChild: node1222.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	node1222 addChild: Node new.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/24/2012 15:18'!
buildSymmetricTreeWithRelations
	"creates a simple Treestructure with relations"
	| nodeList relation |
	nodeList := OrderedCollection new.
	(1 + 4 + 16) timesRepeat: [nodeList add: Node new.].
	2 to: 5 do: [ :i |
		(nodeList at: 1) addChild: (nodeList at: i)
	].
	1 to: 4 do: [ :i |
		1 to: 4 do: [ :j |
			(nodeList at: i + 1) addChild: (nodeList at: (4 * i + j + 1))
		].
	].
	6 to: 21 do: [ :i |
		6 to: 21 do: [ :j |
			(j ~= i) ifTrue: [
				relation := Relation new
					setSource: (nodeList at: i)
					andDestination: (nodeList at: j).
			].
		].
	].
	
	^(nodeList at: 1).! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 10:06'!
buildTestTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111       node112 		node113 		node121 		node122
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:16'!
buildTreeForInterpolation
	"creates a simple Treestructure with a single relation"
	|			 				node1 
				node11 		node12 node13 node14			node15 
	node111    node112 						 			node151 		node152 
							 							node1511	node1512 

	relation112to1511
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node12 := Node new.
	node13 := Node new.
	node14 := Node new.
	node15 := Node new.
	node151 := Node new.
	node152 := Node new.
	node1511 := Node new.
	node1512 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node1 addChild: node13.
	node1 addChild: node14.
	
	node1 addChild: node15.
	node15 addChild: node151.
	node15 addChild: node152.
	node151 addChild: node1511.
	node151 addChild: node1512.
	
	relation112to1511 := Relation new.
	relation112to1511 setSource: node112 andDestination: node1511.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 12/25/2012 13:34'!
buildTreeWithOverlyingRelations
	"creates an x-shaped Treestructure with 3 relations"
	|			 				node1 
			node11 						node12 
	node111    	node112 			node121 		node122

	relation111to121
	relation111to122
	relation112to121
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node111 label: 'A'.
	node112 := Node new.
	node112 label: 'B'.
	node12 := Node new.
	node121 := Node new.
	node121 label: 'C'.
	node122 := Node new.
	node122 label: 'D'.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	
	relation111to122 := Relation new.
	relation111to122 setSource: node111 andDestination: node122.
	relation111to121 := Relation new.
	relation111to121 setSource: node111 andDestination: node121.
	relation112to121 := Relation new.
	relation112to121 setSource: node112 andDestination: node121.

	^node1.! !

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/23/2012 16:52'!
buildTreeWithRelations
	"creates a simple Treestructure with relations"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 

	relation111to112
	relation121to1222
	relation113to1221
	relation113to1222
	|
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	
	relation111to112 := Relation new.
	relation111to112 setSource: node111 andDestination: node112.
	relation121to1222 := Relation new.
	relation121to1222 setSource: node121 andDestination: node1222.
	relation113to1221 := Relation new.
	relation113to1221 setSource: node113 andDestination: node1221.
	relation113to1222 := Relation new.
	relation113to1222 setSource: node113 andDestination: node1222.

	relation113to1222 := Relation new.

	^node1.! !

CircleMorph subclass: #NodeMorph
	instanceVariableNames: 'node gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 20:38'!
addChildNode
	self node addChild: Node new.
	self gui rebuildTree.! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui
	"Answer the value of gui"

	^ gui! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
gui: anObject
	"Set the value of gui"

	gui := anObject! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/25/2012 19:40'!
handlesMouseDown: anEvent
	^true.! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:20'!
mouseDown: anEvent
	self gui clickFromNode: self.! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node
	"Answer the value of node"

	^ node! !

!NodeMorph methodsFor: 'accessing' stamp: 'CR 12/25/2012 19:37'!
node: anObject
	"Set the value of node"

	node := anObject! !

!NodeMorph methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 14:38'!
updateTree
	self gui rebuildTree.! !

RectangleMorph subclass: #MainWindow
	instanceVariableNames: 'rootNode clickState layoutType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

MainWindow subclass: #FDEBMainWindow
	instanceVariableNames: 'nodeP1 nodeP2 nodeQ1 nodeQ2 lineP lineQ morphContainter compatibilityState compatibilityLabel relationLayouter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:19'!
addRelations
	self lineP: (ShapeRenderer drawPolyLine: (OrderedCollection with: (self nodeP1 position) with: (self nodeP2 position)) withWidth: 2).
	self addMorph: self lineP.
	self lineQ: (ShapeRenderer drawPolyLine: (OrderedCollection with: (self nodeQ1 position) with: (self nodeQ2 position)) withWidth: 2).
	self addMorph: self lineQ.! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:43'!
compatibilityLabel
	"Answer the value of compatibilityLabel"

	^ compatibilityLabel! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:43'!
compatibilityLabel: anObject
	"Set the value of compatibilityLabel"

	compatibilityLabel := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:17'!
compatibilityState
	"Answer the value of compatibilityState"

	^ compatibilityState! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:17'!
compatibilityState: anObject
	"Set the value of compatibilityState"

	compatibilityState := anObject! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:03'!
drawBlackCircleAt: aPoint
	| cirlceMorph |
	cirlceMorph := CircleMorph new bounds: ((aPoint - 7) corner: (aPoint  + 7)).
	cirlceMorph color: Color black.
	self addMorph: cirlceMorph.
	self morphContainter add: cirlceMorph.
	^cirlceMorph! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:21'!
drawThinLineFrom: aPoint1 to: aPoint2
	| line |
	line := ShapeRenderer drawPolyLine: (OrderedCollection with: aPoint1 with: aPoint2) withWidth: 1.
	self addMorphBack: line.
	self morphContainter add: line.
	^line! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 09:54'!
fillMainWindow
	"run this method after the size of the main window is set"
	self initializeGraph.
	self initializeRelationLayouter.
	self compatibilityState: 'angle'.
	
	self compatibilityLabel position: (self upperLeftPointOfMainWindow + 5).
	self addMorph: self compatibilityLabel.
	self rebuildMorphs.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:28'!
handlesMouseDown: anEvent
	^true.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:04'!
initialize
	super initialize.
	self clickState: MoveNodeClickState new.
	self morphContainter: OrderedCollection new.
	self compatibilityLabel: TextMorph new.
! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:08'!
initializeGraph
	self rootNode: (TreeBuilder buildFourNodesBetweenLeft: (self upperLeftPointOfMainWindow x + 50) Right: (self lowerRightPointOfMainWindow x - 60) Bottom: (self lowerRightPointOfMainWindow y - 60) Top: (self upperLeftPointOfMainWindow y + 40) For: self).
	self addRelations.
	self rebuildTree.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 22:53'!
initializeRelationLayouter
	| relation1 relation2 |
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	
	self relationLayouter: (RelationLayouterFDEB initializeWithAllRelations: (OrderedCollection with: relation1 with: relation2)).! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 23:18'!
lineP
	"Answer the value of lineP"

	^ lineP! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 23:18'!
lineP: anObject
	"Set the value of lineP"

	lineP := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 23:18'!
lineQ
	"Answer the value of lineQ"

	^ lineQ! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 23:18'!
lineQ: anObject
	"Set the value of lineQ"

	lineQ := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:12'!
morphContainter
	"Answer the value of morphContainter"

	^ morphContainter! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:12'!
morphContainter: anObject
	"Set the value of morphContainter"

	morphContainter := anObject! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:19'!
mouseDown: anEvent
	self clickState handleMainWindowClick: anEvent.
	self updateNodePositions.
	self lineP setVertices: (OrderedCollection with: (self nodeP1 position) with: (self nodeP2 position)).
	self lineQ setVertices: (OrderedCollection with: (self nodeQ1 position) with: (self nodeQ2 position)).
	self rebuildMorphs.! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeP1
	"Answer the value of nodeP1"

	^ nodeP1! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeP1: anObject
	"Set the value of nodeP1"

	nodeP1 := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeP2
	"Answer the value of nodeP2"

	^ nodeP2! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeP2: anObject
	"Set the value of nodeP2"

	nodeP2 := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeQ1
	"Answer the value of nodeQ1"

	^ nodeQ1! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeQ1: anObject
	"Set the value of nodeQ1"

	nodeQ1 := anObject! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeQ2
	"Answer the value of nodeQ2"

	^ nodeQ2! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 10:38'!
nodeQ2: anObject
	"Set the value of nodeQ2"

	nodeQ2 := anObject! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:30'!
rebuildMorphs
	self updateNodePositions.
	self morphContainter do: [:morph | morph abandon.].
	self compatibilityState = 'position' ifTrue: [self showPositionCompatiblity.].
	self compatibilityState = 'scale' ifTrue: [self showScaleCompatiblity.].
	self compatibilityState = 'angle' ifTrue: [self showAngleCompatiblity.].
	self compatibilityState = 'visibility' ifTrue: [self showVisibilityCompatiblity.].
	self compatibilityState = 'full' ifTrue: [self showFullCompatiblity.].! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 21:06'!
rebuildTree
	self rootNode drawNodesOn: self.
	self rootNode drawRelationsOn: self.
	self rootNode nodeRepresentation hide.
	^self rootNode! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:49'!
relationLayouter
	"Answer the value of relationLayouter"

	^ relationLayouter! !

!FDEBMainWindow methodsFor: 'accessing' stamp: 'CR 1/8/2013 22:49'!
relationLayouter: anObject
	"Set the value of relationLayouter"

	relationLayouter := anObject! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:44'!
showAngleCompatiblity
	| relation1 relation2 compatibility auxiliaryPoint q1p1|
	q1p1 := self nodeQ1 position - self nodeP1 position.
	auxiliaryPoint := self nodeQ2 position - q1p1.
	self drawBlackCircleAt: auxiliaryPoint.
	self drawThinLineFrom: self nodeP1 position to: auxiliaryPoint.
	
	
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	compatibility := self relationLayouter calculateAngleCompabilityFor: relation1 And: relation2.
	self compatibilityLabel contents: 'angle compatibility is ', compatibility.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:30'!
showFullCompatiblity
	| relation1 relation2 compatibility |
	
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	compatibility := self relationLayouter calculateCompabilityFor: relation1 And: relation2.
	self compatibilityLabel contents: 'full compatibility is ', compatibility.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:04'!
showPositionCompatiblity
	| pMiddle qMiddle relation1 relation2 compatibility |
	pMiddle := (self nodeP2 positionOfNodeMorph + self nodeP1 positionOfNodeMorph)/2.
	self drawBlackCircleAt: pMiddle.
	
	qMiddle := (self nodeQ2 positionOfNodeMorph + self nodeQ1 positionOfNodeMorph)/2.
	self drawBlackCircleAt: qMiddle.
	
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	compatibility := self relationLayouter calculatePositionCompabilityFor: relation1 And: relation2.
	self compatibilityLabel contents: 'position compatibility is ', compatibility.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:16'!
showScaleCompatiblity	
	| relation1 relation2 compatibility |
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	compatibility := self relationLayouter calculateScaleCompabilityFor: relation1 And: relation2.
	self compatibilityLabel contents: 'scale compatibility is ', compatibility.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/9/2013 10:21'!
showVisibilityCompatiblity
	| relation1 relation2 compatibility auxiliaryPoints |
	
	relation1 := Relation new.
	relation1 setSource: self nodeP1 andDestination: self nodeP2.
	relation2 := Relation new.
	relation2 setSource: self nodeQ1 andDestination: self nodeQ2.
	compatibility := self relationLayouter calculateVisibilityCompabilityFor: relation1 And: relation2.
	auxiliaryPoints := self relationLayouter getI0I1ImFor: relation1 And: relation2.
	auxiliaryPoints size > 2 ifTrue:[
		self drawBlackCircleAt: (auxiliaryPoints at: 1).
		self drawBlackCircleAt: (auxiliaryPoints at: 2).
		self drawBlackCircleAt: (auxiliaryPoints at: 3).
		self drawThinLineFrom: (auxiliaryPoints at: 1) to: (auxiliaryPoints at: 2).].
	self compatibilityLabel contents: 'visibility compatibility is ', compatibility.! !

!FDEBMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 23:12'!
updateNodePositions
	self nodeP1 position: self nodeP1 positionOfNodeMorph.
	self nodeP2 position: self nodeP2 positionOfNodeMorph.
	self nodeQ1 position: self nodeQ1 positionOfNodeMorph.
	self nodeQ2 position: self nodeQ2 positionOfNodeMorph.! !

MainWindow subclass: #GUIMainWindow
	instanceVariableNames: 'layoutType relationOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 16:31'!
addMorph: aMorph atRelativePosition: aPosition withExtend: aCorner
	| left right top bottom frame |
	left := self upperLeftPointOfMainWindow x + (self getWidth * aPosition x).
	top := self upperLeftPointOfMainWindow y + (self getHeight * aPosition y).
	right := self upperLeftPointOfMainWindow x + (self getWidth * aCorner x).
	bottom := self upperLeftPointOfMainWindow y + (self getHeight * aCorner y).
	aMorph bounds: (left@top corner: (right)@(bottom)).
	frame := LayoutFrame new.
	frame
		leftFraction: left;
		rightFraction: right;
		topFraction: top;
		bottomFraction: bottom.
	self addMorph: aMorph fullFrame: frame.
	! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
handlesMouseDown: anEvent
	^true.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/28/2012 11:44'!
initialize
	super initialize.
	self layoutType: 'rooted'.
	self relationOptions: RelationOptions new.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 14:34'!
initializeState
	self clickState: DefaultClickState new.
	self clickState mainWindow: self.! !

!GUIMainWindow methodsFor: 'event handling' stamp: 'CR 11/18/2012 16:01'!
mouseDown: anEvent
	Transcript show: 'mouse Down'.! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:13'!
rebuildRadialTree
	"self removeAllMorphs."
	self rootNode calculateRadialTreeLayoutAtPoint: self getCenter nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 19:44'!
rebuildRootedTree
	"self removeAllMorphs."
	| center |
	center := (self getCenter x)@(self getCenter y - (self getHeight/4)).
	self rootNode calculateRootedTreeLayoutAtPoint: center nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode label: 'src'.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!GUIMainWindow methodsFor: 'as yet unclassified' stamp: 'CR 12/26/2012 20:10'!
rebuildTree
	"self removeAllMorphs."
	self rootNode ifNotNil: [
		self layoutType = 'radial'
			ifTrue: [self rebuildRadialTree]
			ifFalse: [self rebuildRootedTree].].! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:39'!
relationOptions
	"Answer the value of relationOptions"

	^ relationOptions! !

!GUIMainWindow methodsFor: 'accessing' stamp: 'CR 12/28/2012 11:39'!
relationOptions: anObject
	"Set the value of relationOptions"

	relationOptions := anObject! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/8/2013 15:20'!
clickFromNode: aNodeMorph
	self clickState handleNodeClick: aNodeMorph.! !

!MainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 14:33'!
clickState
	"Answer the value of clickState"

	^ clickState! !

!MainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 14:38'!
clickState: anObject
	"Set the value of clickState"

	clickState := anObject.
	clickState mainWindow: self.! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:33'!
getCenter
	"calculates the center of the mainWindow and returns the values as Point"
	| x y |
	x := (self lowerRightPointOfMainWindow) x - (self upperLeftPointOfMainWindow) x.
	x := x/2.
	x := (self upperLeftPointOfMainWindow) x + x.
	y := (self lowerRightPointOfMainWindow) y - (self upperLeftPointOfMainWindow) y.
	y := y/2.
	y := (self upperLeftPointOfMainWindow) y + y.
	^x@y! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:33'!
getHeight
	^(self bounds corner y) - (self bounds origin y)! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
getWidth
	^(self bounds corner x) - (self bounds origin x)! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 13:58'!
layoutType
	"Answer the value of layoutType"

	^ layoutType! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 13:58'!
layoutType: anObject
	"Set the value of layoutType"

	layoutType := anObject! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
lowerRightPointOfMainWindow
	^self bounds corner.! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:52'!
rebuildRadialTree
	"self removeAllMorphs."
	self rootNode calculateRadialTreeLayoutAtPoint: self getCenter nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:52'!
rebuildRootedTree
	"self removeAllMorphs."
	| center |
	center := (self getCenter x)@(self getCenter y - (self getHeight/4)).
	self rootNode calculateRootedTreeLayoutAtPoint: center nodeSize: 20 nodePadding: 10 layerDistance: 30.
	self rootNode drawWithLinesOn: self.
	^self rootNode! !

!MainWindow methodsFor: 'as yet unclassified' stamp: 'CR 1/5/2013 13:08'!
rebuildTree
	"self removeAllMorphs."
	self rootNode ifNotNil: [
		self layoutType = 'radial'
			ifTrue: [self rebuildRadialTree]
			ifFalse: [self rebuildRootedTree].].! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:32'!
rootNode
	"Answer the value of rootNode"

	^ rootNode! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:32'!
rootNode: anObject
	"Set the value of rootNode"

	rootNode := anObject! !

!MainWindow methodsFor: 'accessing' stamp: 'CR 1/5/2013 12:34'!
upperLeftPointOfMainWindow
	^self bounds origin.! !

MainWindow subclass: #PathMainWindow
	instanceVariableNames: 'layoutType source destination step stepCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:11'!
destination
	"Answer the value of destination"

	^ destination! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:11'!
destination: anObject
	"Set the value of destination"

	destination := anObject! !

!PathMainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 21:41'!
highlightPathAndShowDepthFrom: aNode To: anotherNode
	| path |
	path := aNode calculatePathTo: anotherNode.
	aNode highlightPathTo: anotherNode.
	path do: [ :node |
		node label: (node depth asString).
	].! !

!PathMainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 22:50'!
showState
	| lca path i leftDepthFromLCA leftPathFromLCA root leftPathFromRoot leftPathToLCA leftPathToRoot leftDepthFromRoot rightDepthFromRoot rightPathFromRoot rightPathToRoot rightDepthFromLCA rightPathFromLCA rightPathToLCA leftX leftY rightX rightY stepLeftX stepRightX leftNodeForSameDepth rightNodeForSameDepth |
	path := self source calculatePathTo: self destination.
	i:= 1.
	[(path at: i) parent == (path at: (i + 1))] whileTrue: [ i := i + 1. ].
	lca := path at: i.	
	root := self source getRoot.
	leftPathFromLCA := lca calculatePathTo: self source.
	leftPathFromRoot := root calculatePathTo: self source.
	leftPathToLCA := self source calculatePathTo: lca.
	leftPathToRoot := self source calculatePathTo: root.
	leftDepthFromLCA := self source depth - lca depth + 1.
	leftDepthFromRoot := leftPathFromRoot size.
	
	rightPathFromLCA := lca calculatePathTo: self destination.
	rightPathFromRoot := root calculatePathTo: self destination.
	rightPathToLCA := self destination calculatePathTo: lca.
	rightPathToRoot := self destination calculatePathTo: root.
	rightDepthFromLCA := self destination depth - lca depth + 1.
	rightDepthFromRoot := rightPathFromRoot size.

	leftX := 20.
	leftY := 300.
	rightX := 200.
	rightY := 300.
	stepLeftX := 20.
	stepRightX := 20.
	
	leftNodeForSameDepth := self source.
	rightNodeForSameDepth := self destination.
	((leftDepthFromLCA - rightDepthFromLCA) > 0) ifTrue: [
		leftNodeForSameDepth := leftPathToLCA at: (
			leftDepthFromLCA - rightDepthFromLCA + 1).
	].
	((rightDepthFromLCA - leftDepthFromLCA) > 0) ifTrue: [
		rightNodeForSameDepth := rightPathToLCA at: (
			rightDepthFromLCA - leftDepthFromLCA + 1).
	].

	(self step = 'init') ifTrue: [
		(self stepCounter = 0) ifTrue: [
			self source highlightPathTo: self destination.
			^self
		].
		(self stepCounter = 1) ifTrue: [
			self source isHighlighted: true.
			self destination isHighlighted: true.
			^self
		].
		(self stepCounter > 1) ifTrue: [
			self
				step: 'leftDepth';
				stepCounter: 2.
			^self showState.
		].
	].
	self source isHighlighted: true.
	self destination isHighlighted: true.
	(self step = 'leftDepth') ifTrue: [
		"path to root"
		(self stepCounter <= self source depth) ifTrue: [
			self source highlightPathTo: (
				leftPathToRoot at: self stepCounter
			).
			^self 
		].
		"labels from root"
		(self stepCounter <= (2 * self source depth)) ifTrue: [
			self source highlightPathTo: root.
			1 to: (self stepCounter - leftDepthFromRoot) do: [ :index |
				(leftPathFromRoot at: index) label: (index asString).				
			].
			^self 
		].
		self
			step: 'rightDepth';
			stepCounter: 1.
		^self showState.
	].
	self source label: (self source depth asString).
	(self step = 'rightDepth') ifTrue: [
		"path to root"
		(self stepCounter <= self destination depth) ifTrue: [
			self destination highlightPathTo: (
				rightPathToRoot at: self stepCounter
			).
			^self 
		].
		"labels from root"
		(self stepCounter <= (2 * self destination depth)) ifTrue: [
			self destination highlightPathTo: root.
			1 to: (self stepCounter - rightDepthFromRoot) do: [ :index |
				(rightPathFromRoot at: index) label: (index asString).				
			].
			^self 
		].
		self
			step: 'alignDepth';
			stepCounter: 1.
		^self showState.
	].
	self destination label: (self destination depth asString).
	(self step = 'alignDepth') ifTrue: [
		"path to root"
		(self stepCounter <= ((leftDepthFromLCA - rightDepthFromLCA) abs + 1)) ifTrue: [
			((leftDepthFromLCA - rightDepthFromLCA) < 0) ifTrue: [
				self highlightPathAndShowDepthFrom: self destination 
				To: (rightPathToLCA at: self stepCounter).
				"GUIStepperNodeMover new initializeWithParent: self Source: (rightPathToLCA at: self stepCounter) AndTarget: (rightX@rightY)."
			].
			((leftDepthFromLCA - rightDepthFromLCA) > 0) ifTrue: [
				self highlightPathAndShowDepthFrom: self source
				To: (leftPathToLCA at: self stepCounter).
			].
			^self 
		].
		self
			step: 'parallel';
			stepCounter: 2.
		^self showState.
	].
	self highlightPathAndShowDepthFrom: self source To: leftNodeForSameDepth.
	self highlightPathAndShowDepthFrom: self destination To: rightNodeForSameDepth.
	(self step = 'parallel') ifTrue: [
		"path to root"
		(self stepCounter <= (leftNodeForSameDepth depth - lca depth + 1)) ifTrue: [
			leftNodeForSameDepth highlightPathTo: (
				(leftNodeForSameDepth calculatePathTo: lca) at: self stepCounter).
			rightNodeForSameDepth highlightPathTo: (
				(rightNodeForSameDepth calculatePathTo: lca) at: self stepCounter).
			^self 
		].
	].
	self source highlightPathTo: self destination.
	self
		step: 'next';
		stepCounter: 0.
	^'finished!!'



! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:11'!
source
	"Answer the value of source"

	^ source! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:11'!
source: anObject
	"Set the value of source"

	source := anObject! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:26'!
step
	"Answer the value of stepCounter"

	^ step! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:26'!
step: anObject
	"Set the value of step"

	step := anObject! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:26'!
stepCounter
	"Answer the value of stepCounter"

	^ stepCounter! !

!PathMainWindow methodsFor: 'accessing' stamp: 'SL 1/5/2013 17:26'!
stepCounter: anObject
	"Set the value of stepCounter"

	stepCounter := anObject! !

!PathMainWindow methodsFor: 'as yet unclassified' stamp: 'SL 1/5/2013 18:12'!
stepForward
	self rootNode resetAllHighlighting.
	self rootNode resetAllLabels.
	self stepCounter: (self stepCounter + 1).
	self showState.
	self rebuildTree.
	^self ! !
